<?php
/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/
$see_also = 'See also: <a href="help.php?page=categories.php">Products and categories</a>';
?>
<table width="100%" border="0" cellpadding="4" cellspacing="0">
<tr><td class="large">Importing and exporting store data</td></tr>
<tr><td valign="top">
<blockquote><p align="justify">The "Import/Export" section of eShox can be accessed via eShox Admin. Open a Web browser and enter the following URL: http://your-domain-or-ip/shop/admin/. Click on "Import/Export" under "Management" on the left "Administration" window. Import/export options include:

<blockquote>

<p><br /><u>Categories</u></p>
<p align="justify">The "Categories" option is used to import/export category data from/to a tab-delimited text file. Categories imported that already exist will be matched by their category code (which must be unique for each category) and updated with the imported data. Category image file names may be imported with the import/export feature, but the actual image files must be placed in the "/shop/images/" directory.</p>

<p align="justify">When importing categories, an option to disable categories not imported is available, choose this option if you want to disable all categories other than the ones you are importing. To import categories, choose a file to be imported, then click "Import" and map the fields imported to the fields in the database. To Export categories, click "Export".</p>

<p><table border="0" cellpadding="4" cellspacing="0">
  <tr>
	<td bgcolor="C0C0FF" valign="center" align="left">
	  <p align="justify"><b>Notes:</b> Categories that contain sub-categories should be imported before the sub-categories (it is best to sort the import file by parent category name).
	</td>
  </tr>
</table></p>

<p><u>Customer Orders</u></p>
<p align="justify">The "Orders" options are used to export order data to QuickBooks, MYOB, XML or to a tab-delimited text file. Orders exported in QuickBooks format will easily import into QuickBooks for both Windows and Mac OS X.</p>

<p align="justify">The XML format is useful when importing order data into FileMaker or other solutions. The TXT format is more customizable via a set of [tags] that define how the exported file should look. The TXT [tags] include:

<pre>
[address]
[affiliate]
[bill_address]
[cc_expires]
[cc_number]
[cc_owner]
[comments]
[currency]
[currency_value]
[customer_address_2]
[customer_address]
[customer_city]
[customer_company]
[customer_country]
[customer_name]
[customer_postcode]
[customer_state]
[date]
[delivery_address_2]
[delivery_address]
[delivery_city]
[delivery_company]
[delivery_country]
[delivery_name]
[delivery_postcode]
[delivery_state]
[email]
[logo]
[order_id]
[page_title]
[payment_method]
[phone]
[product]
  [option]
	[option_name]
	[option_value]
	[option_price]
  [/option]
  [product_cost]
  [product_id]
  [product_image]
  [product_model]
  [product_name]
  [product_price_extax]
  [product_price_intax]
  [product_sku]
  [product_tax]
  [product_total_extax]
  [product_total_intax]
  [qty]
  [serial_number]
[/product]
[ship_address]
[shipping]
[shipping_method]
[status]
[stylesheet]
[subtotal]
[tax]
[total]
</pre>

<p align="justify">The [product] and [option] tags are repeated for each product and it's product/customer options.</p>

<p><u>Customers</u></p>
<p align="justify">The "Customers" option is used to import/export customer data from/to a tab-delimited text file. New customers imported should have a blank customer ID field; eShox will assign an ID upon import. Customers imported that already exist will be matched by their customer ID and updated with the imported data.</p>

<p align="justify">To import customers, choose a file to be imported, then click "Import" and map the fields imported to the fields in the database. To Export customers, click "Export".</p>

<p><table border="0" cellpadding="4" cellspacing="0">
  <tr>
	<td bgcolor="C0C0FF" valign="center" align="left">
	  <p align="justify"><b>Note:</b> Customers imported that already exist will be updated. The customer password should be MD5 encrypted in the format of encrypted-password:salt.
	</td>
  </tr>
</table></p>

<p><br /><u>Products</u></p>
<p align="justify">The "Products" option is used to import/export product data from/to a tab-delimited text file. Products imported that already exist will be matched by their product model (which must be unique for each product) and updated with the imported data.</p>

<p align="justify">The categories must be imported (or created in the "Categories & Products" section of eShox Admin) before products are imported (export categories to see what their category codes are). As the product description field may contain return characters, you must end each product record imported with a tab and the characters 'EOR' to designate 'end of record'. Product image file names may be imported with the import/export feature, but the actual image files must be placed in the "/shop/images/" directory.</p>

<p align="justify">When importing products, an option to disable products not imported is available, choose this option if you want to disable all products other than the ones you are importing. To import products, choose a file to be imported, then click "Import" and map the fields imported to the fields in the database. To Export products, click "Export".</p>

<p><table border="0" cellpadding="4" cellspacing="0">
  <tr>
	<td bgcolor="C0C0FF" valign="center" align="left">
	  <p align="justify"><b>Notes:</b> Products imported that already exist will be updated. Each row of data imported must end with '[tab]EOR' (designates end of record). Categories must be created before products are imported. Products with categories that do not exist will be placed in the 'top' category. Products should have one record for each language currently enabled in the store. Product images should be placed in the /shop/images directory (only the image filenames should be imported here).
	</td>
  </tr>
</table></p>

<p><u>Product Options</u></p>
<p align="justify">The "Product Options Data" option is used to import/export product options data from/to a tab-delimited text file. New products options imported should have a blank product options ID field; eShox will assign an ID upon import. Product options imported that already exist will be matched by their product options ID and updated with the imported data.</p>

<p align="justify">When importing product options data, an option to delete existing products options is available. Choose this option if you want to delete  all products options other than the ones you are importing. To import product options data, choose a file to be imported, then click "Import" and map the fields imported to the fields in the database. To Export product options data, click "Export".</p>

<p><table border="0" cellpadding="4" cellspacing="0">
  <tr>
	<td bgcolor="C0C0FF" valign="center" align="left">
	  <p align="justify"><b>Notes:</b> Option names and values must be created before products are imported. Product option images should be placed in the /shop/images directory (only the image filenames should be imported here).
	</td>
  </tr>
</table></p>

</blockquote>

</blockquote>

</tr>
</table>