<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

if (!$_SESSION['customer_id'] && MYSELF != 'shopping_cart.php') {
  shop_redirect(shop_href_link('login.php', 'url=' . urlencode(MYSELF), 'SSL'));
}

if ($_SESSION['cart']->count_contents() == 0) {
  shop_redirect(shop_href_link('shopping_cart.php', '', 'NONSSL'));
}

$any_out_of_stock = 0;
if (STOCK_CHECK == 'true') {
  foreach ($_SESSION['cart']->contents as $product_id => $product_info) {
	$products_id = shop_get_prid($product_id);
	$stock = shop_db_fetch_array(shop_db_query("select products_quantity from " . DB_PREFIX . "products where products_id = '$products_id'"));
	if (($stock['products_quantity'] - $product_info['qty']) < 0) $any_out_of_stock = 1;
  }
  if (STOCK_ALLOW_CHECKOUT != 'true' && $any_out_of_stock) shop_redirect(shop_href_link('shopping_cart.php', 'error_message=OUT_OF_STOCK_CANT_CHECKOUT', 'SSL'));
}

return true;

class shipping {
  var $modules = array(), $shipping_count = 0;

  function shipping() {
		if (MODULE_SHIPPING_INSTALLED) {
			foreach (explode(';', MODULE_SHIPPING_INSTALLED) as $file) {
				include(DIR_FS_CONTENTS . 'shipping/' . $file);
				$class = substr($file, 0, strrpos($file, '.'));
				$this->modules[] = $class;
				$GLOBALS[$class] = new $class;
			}
		}
  }

  function selection() {
		$selection_string = '';
		if (MODULE_SHIPPING_INSTALLED) {
			foreach ($this->modules as $class) {
				if ($GLOBALS[$class]->enabled) {
					$selection_string .= $GLOBALS[$class]->selection();
				}
			}
		}
	
		return $selection_string;
  }

  function quote() {
		global $total_weight, $total_count, $shipping_weight, $shipping_num_boxes;
	
		if (MODULE_SHIPPING_INSTALLED) {
			if ($total_weight > 0) {
				$shipping_num_boxes = 1;
				$shipping_weight = $total_weight + SHIPPING_PACKWEIGHT;
			}
			if ($total_weight + SHIPPING_PACKWEIGHT > 150) {
				$shipping_num_boxes = ceil($total_weight/150);
				$shipping_weight = ($total_weight/$shipping_num_boxes) + SHIPPING_PACKWEIGHT;
			}
			$shipping_cheapest = false;
			$shipping_cheapest_cost = 9999;
			foreach ($this->modules as $class) {
				if ($GLOBALS[$class]->enabled) {
					$cost = $GLOBALS[$class]->quote();
					if ($cost) $this->shipping_count++;
					if ($cost < $shipping_cheapest_cost) {
						$shipping_cheapest = $class;
						$shipping_cheapest_cost = $cost;
					}
				}
			}
			if ($shipping_cheapest) $GLOBALS[$shipping_cheapest]->selected = true;
		}
  }

  function display() {
		if (MODULE_SHIPPING_INSTALLED) {
			$display_string = '';
			foreach ($this->modules as $class) {
				if ($GLOBALS[$class]->enabled) {
					$selected = (int) @$GLOBALS[$class]->selected; $i=0;
					foreach ($GLOBALS[$class]->quote as $display_quote) {
						$display_string .= '	<tr><td width="24" height="24" align="right">';
						if (sizeof($display_quote) > 1) {
							$display_string .= shop_draw_selection_field('shipping_selected', 'radio', $GLOBALS[$class]->code . $i, $selected) .
												 shop_draw_hidden_field($GLOBALS[$class]->code . $i . '_cost', $display_quote['TotalCharges']) .
												 shop_draw_hidden_field($GLOBALS[$class]->code . $i . '_method', $display_quote['Method']);
						}
						else {
							$display_string .= shop_draw_hidden_field('shipping_selected', $GLOBALS[$class]->code . $i, false) .
												 shop_draw_hidden_field($GLOBALS[$class]->code . $i . '_cost', $display_quote['TotalCharges']) .
												 shop_draw_hidden_field($GLOBALS[$class]->code . $i . '_method', $display_quote['Method']);
						}
						$display_string .= '</td>' . UNIX_RETURN;
						$display_string .= '		<td width="32" align="center">' . (($GLOBALS[$class]->icon) ? shop_image($GLOBALS[$class]->icon, $display_quote['Service'], 0, 0, '', false) : '') . '</td>' . UNIX_RETURN .
											 '		<td valign="center" class="body">' . $display_quote['Service'] . '</td>' . UNIX_RETURN .
											 '		<td align="right" class="body">' . $GLOBALS['currencies']->format($display_quote['TotalCharges']) . ' &nbsp; </td></tr>' . UNIX_RETURN;
						$selected = 0; $i++;
					}
				}
			}
			return $display_string;
		}
  }

  function confirm() {
		if (MODULE_SHIPPING_INSTALLED) {
			global $shipping_cost, $shipping_method;
			$shipping_cost = $_POST[$_POST['shipping_selected'] . '_cost'];
			$shipping_method = $_POST[$_POST['shipping_selected'] . '_method'];
		}
  }
}

class payment {
  var $modules = array();

  function payment() {
		if (MODULE_PAYMENT_INSTALLED) {
			foreach (explode(';', MODULE_PAYMENT_INSTALLED) as $file) {
				include(DIR_FS_CONTENTS . 'payment/' . $file);
				$class = substr($file, 0, strrpos($file, '.'));
				$this->modules[] = $class;
	
				$GLOBALS[$class] = new $class;
			}
		}
  }

  function javascript_validation() {
		$javascript_validation_string = '';
		if (MODULE_PAYMENT_INSTALLED) {
			foreach ($this->modules as $class) {
				if ($GLOBALS[$class]->enabled) {
					$javascript_validation_string .= $GLOBALS[$class]->javascript_validation();
				}
			}
		}
	
		return $javascript_validation_string;
  }

  function selection() {
		$selection_string = '';
		$content_string = '';
		$js = '';
		$js_i = 0;
		if (MODULE_PAYMENT_INSTALLED) {
			foreach ($this->modules as $class) {
				if ($GLOBALS[$class]->enabled) {
					$selection_string .= shop_draw_radio_field('payment_selected', $GLOBALS[$class]->code, 0, 'onclick="payment_is_checked(\'' . $GLOBALS[$class]->code . '\')"') .
								 '&nbsp;' . $GLOBALS[$class]->shop_title;
					$js .= "pay_types[" . $js_i++ . "] = '" . $GLOBALS[$class]->code . "'; 
					";
					$content_string .= '<tr><td colspan="2"><span class="hidden" id="' . $GLOBALS[$class]->code . '">' . $GLOBALS[$class]->selection() . '</span></td></tr>';
				}
			}
		}
	
		return '<tr><td height="24" align="left" class="body">' . $selection_string . '
		<script language="javascript"><!--
			var pay_types = new Array();
			' . $js . '
		//--></script></td></tr>' . $content_string;
  }

  function pre_confirmation_check() {
		if (MODULE_PAYMENT_INSTALLED) {
			foreach ($this->modules as $class) {
				if ( ($GLOBALS[$class]->code == $_POST['payment_selected']) && ($GLOBALS[$class]->enabled) ) {
					$GLOBALS[$class]->pre_confirmation_check();
				}
			}
		}
  }

  function confirmation() {
		$confirmation_string = '';
		if (MODULE_PAYMENT_INSTALLED) {
			foreach ($this->modules as $class) {
				if ( ($GLOBALS[$class]->code == $_POST['payment_selected']) && ($GLOBALS[$class]->enabled) ) {
					$confirmation_string .= '  <tr>' . UNIX_RETURN .
																	'    <td class="body"> &nbsp; ' . $GLOBALS[$class]->shop_title . $GLOBALS[$class]->confirmation() . '</td>' . UNIX_RETURN .
																	'  </tr>' . UNIX_RETURN;
				}
			}
		}
	
		return $confirmation_string;
  }

  function process_button() {
		$process_button_string = '';
		if (MODULE_PAYMENT_INSTALLED) {
			foreach ($this->modules as $class) {
				if ( ($GLOBALS[$class]->code == $_POST['payment_selected']) && ($GLOBALS[$class]->enabled) ) {
					$process_button_string .= $GLOBALS[$class]->process_button();
				}
			}
		}
	
		return $process_button_string;
  }

  function before_process() {
		if (MODULE_PAYMENT_INSTALLED) {
			foreach ($this->modules as $class) {
				if ( ($GLOBALS[$class]->code == $_SESSION['cart']->info['payment_selected']) && ($GLOBALS[$class]->enabled) ) {
					$GLOBALS[$class]->before_process();
				}
			}
		}
  }

  function after_process() {
		if (MODULE_PAYMENT_INSTALLED) {
			foreach ($this->modules as $class) {
				if ( ($GLOBALS[$class]->code == $_SESSION['cart']->info['payment_selected']) && ($GLOBALS[$class]->enabled) ) {
					$GLOBALS[$class]->after_process();
				}
			}
		}
		if (CLEAR_CART != 'false') $_SESSION['cart'] = array();
  }
}

class order_total {
  var $modules = array();

  function order_total() {
	$directory = DIR_FS_CONTENTS . 'order_total/';
	if ($dir = @dir($directory)) {
	  while ($file = $dir->read()) {
	    if (substr($file, -3) != 'php') continue;
	    require(DIR_FS_CONTENTS . 'order_total/' . $file);
	    $class = substr($file, 0, strrpos($file, '.'));

	    $GLOBALS[$class] = new $class;
	    $this->modules[$GLOBALS[$class]->sort_order] = $class;
	    
	  }
	  ksort($this->modules);
	}
  }

  function process() {
	$order_total_array = array();
	if ($this->modules) {
	  foreach ($this->modules as $class) {
	    if ($GLOBALS[$class]->enabled) {
	      $GLOBALS[$class]->process();
	      for ($i=0; $i<sizeof($GLOBALS[$class]->output); $i++) {
	        if ($GLOBALS[$class]->output[$i]['title'] && $GLOBALS[$class]->output[$i]['text']) {
	          $order_total_array[] = array('code' => $GLOBALS[$class]->code,
	                                       'title' => $GLOBALS[$class]->output[$i]['title'],
	                                       'text' => $GLOBALS[$class]->output[$i]['text'],
	                                       'value' => $GLOBALS[$class]->output[$i]['value'],
	                                       'sort_order' => $GLOBALS[$class]->sort_order);
	        }
	      }
	    }
	  }
	}

	return $order_total_array;
  }

  function output() {
	$output_string = '';
	if ($this->modules) {
	  foreach ($this->modules as $class) {
	    if ($GLOBALS[$class]->enabled) {
	      for ($i=0; $i<sizeof($GLOBALS[$class]->output); $i++) {
	        $output_string .= '              <tr><td colspan="2">' . shop_draw_separator('pixel_trans.gif', '100%', '3') . '</td></tr>' . UNIX_RETURN .
	                          '              <tr>' . UNIX_RETURN .
	                          '                <td align="right" class="body">' . $GLOBALS[$class]->output[$i]['title'] . '&nbsp;</td>' . UNIX_RETURN .
	                          '                <td align="right" class="body" width="70">' . $GLOBALS[$class]->output[$i]['text'] . '&nbsp;</td>' . UNIX_RETURN .
	                          '              </tr>';
	      }
	    }
	  }
	}

	return $output_string;
  }
}

class order {
  var $info, $totals, $products, $customer, $delivery;

  function order() {
	$this->info = array();
	$this->totals = array();
	$this->products = array();
	$this->customer = array();
	$this->delivery = array();

	$this->load_cart();
  }
  
  function load_cart() {
	$customer_address_query = shop_db_query("select now() as orderdate, c.*, ab.*, z.zone_name, co.* from " . DB_PREFIX . "customers c, " . DB_PREFIX . "address_book ab left join " . DB_PREFIX . "zones z on (ab.entry_zone_id = z.zone_id) left join " . DB_PREFIX . "countries co on (ab.entry_country_id = co.countries_id) where c.customers_id = '" . $_SESSION['customer_id'] . "' and ab.customers_id = '" . $_SESSION['customer_id'] . "' and c.customers_default_address_id = ab.address_book_id");
	$customer_address = shop_db_fetch_array($customer_address_query);

	$shipping_address_query = shop_db_query("select ab.*, z.zone_name, c.countries_name, c.address_format_id from " . DB_PREFIX . "address_book ab left join " . DB_PREFIX . "zones z on (ab.entry_zone_id = z.zone_id) left join " . DB_PREFIX . "countries c on (ab.entry_country_id = c.countries_id) where ab.customers_id = '" . $_SESSION['customer_id'] . "' and ab.address_book_id = '2'");
	$shipping_address = shop_db_fetch_array($shipping_address_query);

	if (@$_SESSION['cart']->coupons) {
		$this->coupons = $_SESSION['cart']->coupons;
	} else {
		$this->coupons = array();
	}
	
	$this->info = array('currency' => $_SESSION['currency'],
	                    'currency_value' => $GLOBALS['currencies']->currencies[$_SESSION['currency']]['value'],
	                    'cc_type' => $_SESSION['cart']->info['cc_type'],
	                    'cc_owner' => $_SESSION['cart']->info['cc_owner'],
	                    'cc_number' => $_SESSION['cart']->info['cc_number'],
	                    'cc_expires' => $_SESSION['cart']->info['cc_expires'],
	                    'cc_code' => $_SESSION['cart']->info['cc_code'],
	                    'payment_method' => $_SESSION['cart']->info['payment_method'],
	                    'payment_selected' => $_SESSION['cart']->info['payment_selected'],
	                    'shipping_method' => $_SESSION['cart']->info['shipping_method'],
	                    'shipping_cost' => $_SESSION['cart']->info['shipping_cost'],
	                    'coupons' => '-' . @$_SESSION['cart']->info['coupons'],
	                    'comments' => @$_SESSION['cart']->info['comments'],
	                    'date_purchased' => $customer_address['orderdate']);
	                    
	$this->customer = array('firstname' => $customer_address['customers_firstname'],
	                        'lastname' => $customer_address['customers_lastname'],
	                        'name' => $customer_address['customers_firstname'] . ' ' . $customer_address['customers_lastname'],
	                        'company' => $customer_address['entry_company'],
	                        'street_address' => $customer_address['entry_street_address'],
	                        'street_address_2' => $customer_address['entry_street_address_2'],
	                        'city' => $customer_address['entry_city'],
	                        'postcode' => $customer_address['entry_postcode'],
	                        'state' => (($customer_address['entry_state']) ? $customer_address['entry_state'] : $customer_address['zone_name']),
	                        'country' => $customer_address['countries_name'],
	                        'country_code' => $customer_address['countries_iso_code_2'],
	                        'format_id' => $customer_address['address_format_id'],
	                        'telephone' => $customer_address['customers_telephone'],
	                        'email_address' => $customer_address['customers_email_address']);

	$this->delivery = array('firstname' => $shipping_address['entry_firstname'],
	                        'lastname' => $shipping_address['entry_lastname'],
	                        'name' => $shipping_address['entry_firstname'] . ' ' . $shipping_address['entry_lastname'],
	                        'company' => $shipping_address['entry_company'],
	                        'street_address' => $shipping_address['entry_street_address'],
	                        'street_address_2' => $shipping_address['entry_street_address_2'],
	                        'city' => $shipping_address['entry_city'],
	                        'postcode' => $shipping_address['entry_postcode'],
	                        'state' => (($shipping_address['entry_state']) ? $shipping_address['entry_state'] : $shipping_address['zone_name']),
	                        'country' => $shipping_address['countries_name'],
	                        'country_id' => $shipping_address['entry_country_id'],
	                        'format_id' => $shipping_address['address_format_id']);

	$this->manufacturers = array();
	$this->products = array();
	
	foreach ($_SESSION['cart']->contents as $product_id => $product_info) {
	  $manufacturer_query = shop_db_query('select m.manufacturers_email from ' . DB_PREFIX . 'products p, ' . DB_PREFIX . 'manufacturers m where products_id = "' . $product_id . '" and m.manufacturers_id = p.manufacturers_id;');
	  $manufacturer = shop_db_fetch_array($manufacturer_query);
	  
	  if (!in_array($manufacturer['manufacturers_email'], $this->manufacturers)) {
	    $this->manufacturers[] = $manufacturer['manufacturers_email'];
	  }
	  
	  // get categories this product belongs to, to calculate for coupons
		$cat_result = shop_db_query("select categories_id from " . DB_PREFIX . "products_to_categories where products_id = '" . $product_info['products_id'] . "'");
		$cats = array();
		while ($row = shop_db_fetch_array($cat_result)) $cats[] = $row['categories_id'];

	  $this->products[$product_id] = array('qty' => $product_info['qty'],
	                                       'name' => $product_info['products_name'],
	                                       'model' => $product_info['products_model'],
	                                       'image' => $product_info['products_image'],
	                                       'tax' => shop_get_tax_rate($product_info['products_tax_class_id']),
	                                       'sku' => $product_info['products_sku'],
	                                       'turn_off' => $product_info['products_turnoff_sold'],
	                                       'price' => $product_info['price'],
	                                       'cost' => $product_info['products_cost'],
	                                       'final_price' => $product_info['price'] + $_SESSION['cart']->attributes_price($product_id),
	                                       'weight' => @$product_info['weight'],
	                                       'id' => $product_info['products_id'],
	                                       'manufacturers_id' => $product_info['manufacturers_id'],
	                                       'categories' => $cats);

	  if (@$product_info['attributes']) {
	    foreach ($product_info['attributes'] as $attributes_id => $attributes) {

	      $this->products[$product_id]['attributes'][$attributes_id] = array('option' => $attributes['products_options_name'],
							 'value' => $attributes['products_options_values_name'],
							 'option_id' => $attributes['options_id'],
							 'value_id' => $attributes['options_values_id'],
							 'options_model' => $attributes['options_model'],
							 'image' => $attributes['attribute_image'],
							 'price' => $attributes['options_values_price'],
							 'prefix' => $attributes['price_prefix']);
	    }
	  }
	  
	  if (@$product_info['customer_options']) {
	    foreach ($product_info['customer_options'] as $customer_options_id => $customer_options) {
	      $this->products[$product_id]['customer_options'][$customer_options_id]['customer_options_name'] = $customer_options['customer_options_options_name'];
	      $this->products[$product_id]['customer_options'][$customer_options_id]['customer_options_id'] = $customer_options['customer_options_id'];
	      $this->products[$product_id]['customer_options'][$customer_options_id]['customer_options_type'] = $customer_options['options_type'];
	      $this->products[$product_id]['customer_options'][$customer_options_id]['customer_options_value'] = $customer_options['customer_options_options_value'];
	      $this->products[$product_id]['customer_options'][$customer_options_id]['locx'] = $customer_options['locx'];
	      $this->products[$product_id]['customer_options'][$customer_options_id]['locy'] = $customer_options['locy'];
	    }
	  }

	  $shown_price = $this->products[$product_id]['final_price'] * $this->products[$product_id]['qty'];
	  
	  @$this->info['subtotal'] += $shown_price;

	  @$this->info['tax'] += ($this->products[$product_id]['tax'] / 100) * $shown_price;
	  @$this->info['tax_groups']["{$this->products[$product_id]['tax']}"] += ($this->products[$product_id]['tax'] / 100) * $shown_price;
	}

	if (DISPLAY_PRICE_WITH_TAX == 'true') {
	  $this->info['total'] = $this->info['subtotal'] + $this->info['tax'] + $this->info['shipping_cost'];
	  $this->info['subtotal'] += $this->info['tax'];
	} else {
	  $this->info['total'] = $this->info['subtotal'] + $this->info['tax'] + $this->info['shipping_cost'];
	}
  }
}

function shop_validate_cc($cc_owner, $cc_number, $cc_expires_month, $cc_expires_year, $cc_code) {
	$cc_expires = ($cc_expires_month . $cc_expires_year);
	if ($cc_expires_year . $cc_expires_month < date("ym")) shop_invalid_cc(TEXT_CCVAL_ERROR_INVALID_DATE);
	$numbers = preg_split('//', strrev(ereg_replace("[^0-9]", "", $cc_number)), -1, PREG_SPLIT_NO_EMPTY);
	$checksum = 0;
	foreach($numbers as $loc=>$num) {
		if ($loc/2 != floor($loc/2)) {
			$num *= 2;
			if ($num > 9) $num = substr($num,0,1) + substr($num,-1,1);
		}
		$checksum += $num;
	}
	if (!($checksum % 10 == 0)) shop_invalid_cc(TEXT_CCVAL_ERROR_INVALID_NUMBER);
	$card_types = array('American Express' => ereg("^3[47].{13}$", $cc_number),
						'Delta' => ereg("^4.{15}$", $cc_number),
						'Diners Club' => ereg("^30[0-5].{11}$|^3[68].{12}$", $cc_number),
						'Discover Card' => ereg("^6011.{12}$", $cc_number),
						'EnRoute' => ereg("^2014.{11}$|^2149.{11}$", $cc_number),
						'JCB' => ereg("^3.{15}$|^2131|1800.{11}$", $cc_number),
						'Switch' => ereg("^[456].{15}$|^[456].{17,18}$", $cc_number),
						'Visa' => ereg("^4.{15}$|^4.{12}$", $cc_number),
						'MasterCard' => ereg("^5[1-5].{14}$", $cc_number));
	$cc_type = null;
	foreach($card_types as $card_type=>$match) if ($match == 1) $cc_type = $card_type;
	if (!$cc_type) shop_invalid_cc(TEXT_CCVAL_ERROR_UNKNOWN_CARD);

	$_SESSION['cart']->info = array('cc_owner' => $cc_owner,
						'cc_number' => ereg_replace("[^0-9]", "", $cc_number),
						'cc_expires' => $cc_expires,
						'cc_code' => $cc_code,
						'cc_type' => $cc_type);
}

function shop_invalid_cc($message) {
	shop_redirect(shop_href_link('checkout_payment.php', 'error_message=' . urlencode($message), 'SSL'));
}

function shop_draw_cc_input() {
	$expires_month = array(array('id' => '', 'text' => ''));
	for ($i=1; $i < 13; $i++) {
	  $expires_month[] = array('id' => sprintf('%02d', $i), 'text' => strftime('%B',mktime(0,0,0,$i,1,2000)));
	}
	
	$expires_year = array(array('id' => '', 'text' => ''));
	$today = getdate(); 
	for ($i=$today['year']; $i < $today['year']+10; $i++) {
	  $expires_year[] = array('id' => strftime('%y',mktime(0,0,0,1,1,$i)), 'text' => strftime('%Y',mktime(0,0,0,1,1,$i)));
	}
	
	$customers_name = shop_db_fetch_array(shop_db_query("select entry_firstname as firstname, entry_lastname as lastname from " . DB_PREFIX . "address_book where customers_id = '" . $_SESSION['customer_id'] . "'"));
	
	$selection_string = '<blockquote><table border="0" cellspacing="0" cellpadding="5">
		<tr>
			<td class="body">&nbsp;' . MODULE_PAYMENT_CC_TEXT_CREDIT_CARD_OWNER . 
				'<br />' . shop_draw_input_field('cc_owner', $customers_name['firstname'] . ' ' . $customers_name['lastname']) . '&nbsp;</td>
			<td class="body">&nbsp;' . MODULE_PAYMENT_CC_TEXT_CREDIT_CARD_NUMBER . 
				'<br />' . shop_draw_input_field('cc_number') . '&nbsp; </td>
			<td class="body">&nbsp;' . MODULE_PAYMENT_CC_TEXT_SECURITY_CODE . 
				'<br />' . shop_draw_input_field('cc_code', '', 'size="6"') . '&nbsp; </td>
		</tr>
		<tr>
			<td class="body">&nbsp;' . MODULE_PAYMENT_CC_TEXT_CREDIT_CARD_EXPIRES . 
				'<br />' . shop_draw_pull_down_menu('cc_expires_month', $expires_month) . '&nbsp;/&nbsp;' . shop_draw_pull_down_menu('cc_expires_year', $expires_year) . '</td>
			<td class="body" valign="bottom" align="left" colspan="2">&nbsp;' . CC_SYMBOLS . '</td>
		</tr>
	</table></blockquote>' . UNIX_RETURN;
	
	return $selection_string;
}

function shop_draw_cc_javascript_validation($code) {
	$validation_string = 'if (payment_value == "' . $code . '") {
	var cc_owner = document.payment.cc_owner.value;
	var cc_number = document.payment.cc_number.value;
	var cc_code = document.payment.cc_code.value;
	if (cc_owner == "" || cc_owner.length < ' . CC_OWNER_MIN_LENGTH . ') {
		error_message = error_message + "' . MODULE_PAYMENT_CC_TEXT_JS_CC_OWNER . '";
		error = 1;
	}
	if (cc_number == "" || cc_number.length < ' . CC_NUMBER_MIN_LENGTH . ') {
		error_message = error_message + "' . MODULE_PAYMENT_CC_TEXT_JS_CC_NUMBER . '";
		error = 1;
	}
	if (cc_code == "" || cc_code.length < 3) {
		error_message = error_message + "' . MODULE_PAYMENT_CC_TEXT_JS_CVV_NUMBER . '";
		error = 1;
	}
}
';

	return $validation_string;
}
