<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/

  class ot_loworderfee {
	var $title, $output;

	function ot_loworderfee() {
	  $this->code = 'ot_loworderfee';
	  $this->title = MODULE_ORDER_TOTAL_LOWORDERFEE_TITLE;
	  $this->description = 'Low Order Fee Options:';
	  $this->enabled = defined('MODULE_ORDER_TOTAL_LOWORDERFEE_STATUS');
	  $this->sort_order = 7;

	  $this->output = array();
	}

	function process() {
	  global $order;

	  switch (MODULE_ORDER_TOTAL_LOWORDERFEE_DESTINATION) {
	    case 'national':
	      if ($order->delivery['country_id'] == STORE_COUNTRY_ID) $pass = true; break;
	    case 'both':
	    case 'international':
	      $pass = true; break;
	    default:
	      $pass = false; break;
	  }

	  if ( ($pass == true) && ( ($order->info['subtotal']) <= MODULE_ORDER_TOTAL_LOWORDERFEE_ORDER_UNDER) ) {
	    $tax = shop_get_tax_rate(MODULE_ORDER_TOTAL_LOWORDERFEE_TAX_CLASS);
	    // is low order fee calculated as full amount or difference of order subtotal
			$low_order_fee = (MODULE_ORDER_TOTAL_LOWORDERFEE_TYPE == 'full') 
				? MODULE_ORDER_TOTAL_LOWORDERFEE_FEE
				: MODULE_ORDER_TOTAL_LOWORDERFEE_FEE - $order->info['subtotal'];
			
	    $order->info['tax'] += shop_calculate_tax($low_order_fee, $tax);
	    $order->info['tax_groups']["{$tax}"] += shop_calculate_tax($low_order_fee, $tax);
	    $order->info['total'] += $low_order_fee + shop_calculate_tax($low_order_fee, $tax);

	    $this->output[] = array('title' => $this->title . ':',
	                            'text' => '<span style="color:#ff0000;">' . $GLOBALS['currencies']->format(shop_add_tax($low_order_fee, $tax), true, $order->info['currency'], $order->info['currency_value']) . '</span>',
	                            'value' => shop_add_tax($low_order_fee, $tax));
	  }
	}

	function check() {
	  return defined('MODULE_ORDER_TOTAL_LOWORDERFEE_STATUS');
	}

	function keys() {
	  return array('MODULE_ORDER_TOTAL_LOWORDERFEE_STATUS', 'MODULE_ORDER_TOTAL_LOWORDERFEE_ORDER_UNDER', 'MODULE_ORDER_TOTAL_LOWORDERFEE_FEE',
	  	'MODULE_ORDER_TOTAL_LOWORDERFEE_TYPE',
	  	'MODULE_ORDER_TOTAL_LOWORDERFEE_DESTINATION', 'MODULE_ORDER_TOTAL_LOWORDERFEE_TAX_CLASS');
	}

	function install() {
		$i = 1;
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_ORDER_TOTAL_LOWORDERFEE_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, date_added) values ('Order Fee For Orders Under', 'MODULE_ORDER_TOTAL_LOWORDERFEE_ORDER_UNDER', '50', 'Add the low order fee to orders under this amount.', '6', '" . ($i++) . "', 'currencies->format', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, date_added) values ('Order Fee', 'MODULE_ORDER_TOTAL_LOWORDERFEE_FEE', '5', 'Low order fee.', '6', '" . ($i++) . "', 'shop_cfg_price_display(', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Apply to Orders Made', 'MODULE_ORDER_TOTAL_LOWORDERFEE_DESTINATION', 'international', 'Attach low order fee for orders sent to the following destination.', '6', '" . ($i++) . "', 'shop_cfg_select_option(array(\'national\', \'international\', \'both\'), ', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Charge Calculation', 'MODULE_ORDER_TOTAL_LOWORDERFEE_TYPE', 'full', 'Fee can be either the full fee, or the difference between the order and low order fee amount.', '6', '" . ($i++) . "', 'shop_cfg_select_option(array(\'full\', \'difference\'), ', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, use_function, set_function, date_added) values ('Tax Class', 'MODULE_ORDER_TOTAL_LOWORDERFEE_TAX_CLASS', '0', 'Use the following tax class on the low order fee.', '6', '" . ($i++) . "', 'shop_get_tax_class_title', 'shop_cfg_pull_down_tax_classes(', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key in ('" . implode("','", $this->keys()) . "')");
	}
}
