<?php

/*
  eShox 3 Commerce Solution
  http://www.eshox.com/
  
  Copyright (c) 2003, Secure.cc, Inc.

*/

class authorizenet {
	var $code, $title, $description, $enabled;

	function authorizenet() {
	  $this->code = 'authorizenet';
	  $this->title = 'Authorize.net';
	  $this->shop_title = MODULE_PAYMENT_CC_TEXT_TITLE;
	  $this->description = '';
	  $this->signup = 'http://www.baskettcase.com/downloads/authorize_net.pdf';
	  $this->enabled = defined('MODULE_PAYMENT_AUTHORIZENET_STATUS');
	  $this->recommend_level = 5;
	  $this->version = "1.1";
	}

	function javascript_validation() {
	  return shop_draw_cc_javascript_validation($this->code);
	}

	function selection() {
	  return shop_draw_cc_input();
	}

	function pre_confirmation_check() {
	  if ($_POST['payment_selected'] == $this->code) shop_validate_cc($_POST['cc_owner'],$_POST['cc_number'], $_POST['cc_expires_month'], $_POST['cc_expires_year'], $_POST['cc_code']);
	}

	function confirmation() {
	}

	function process_button() {
	  $process_button_string = shop_draw_hidden_field('cc_owner', $_POST['cc_owner']) . 
	                           shop_draw_hidden_field('cc_number', $_POST['cc_number']) . 
	                           shop_draw_hidden_field('cc_code', $_POST['cc_code']) . UNIX_RETURN .
	                           shop_draw_hidden_field('cc_expires', $_POST['cc_expires_month'] . substr($_POST['cc_expires_year'], -2)) . UNIX_RETURN;

	  return $process_button_string;
	}
	
	function before_process() {
		global $order;
		
		$cc_owner = strrev($_POST['cc_owner']);
		$cc_owner_firstname = strrev(substr($cc_owner, strpos($cc_owner, ' ')+1));
		$cc_owner_lastname =strrev( substr($cc_owner, 0, strpos($cc_owner, ' ')));

		$data_array = array('x_Login' => MODULE_PAYMENT_AUTHORIZENET_LOGIN,
							'x_Password' => MODULE_PAYMENT_AUTHORIZENET_PASSWORD,
							'x_Test_Request' => ((MODULE_PAYMENT_AUTHORIZENET_TESTMODE == 'Test') ? 'TRUE' : 'FALSE'),
							'x_Version' => '3.1',
							'x_Invoice_Num' => $order->info['orders_id'],
							'x_ADC_URL' => 'FALSE',
							'x_Delim_Data' => 'TRUE',
							'x_Delim_Char' => ',',
							'x_Encap_Char' => '|',
							'x_Type' => 'AUTH_CAPTURE',
							'x_Method' => 'CC',
							'x_Amount' => number_format($order->info['total'], 2),
							'x_Card_Num' => $_POST['cc_number'],
							'x_Exp_Date' => $_POST['cc_expires'],
							'x_Card_Code' => $_POST['cc_code'],
							'x_Cust_ID' => $_SESSION['customer_id'],
							'x_First_Name' => $cc_owner_firstname,
							'x_Last_Name' => $cc_owner_lastname,
							'x_Company' => $order->customer['company'],
							'x_Address' => $order->customer['street_address'],
							'x_City' => $order->customer['city'],
							'x_State' => $order->customer['state'],
							'x_Zip' => $order->customer['postcode'],
							'x_Country' => $order->customer['country'],
							'x_Phone' => $order->customer['telephone'],
							'x_Fax' => $order->customer['fax'],
							'x_email' => $order->customer['email_address'],
							'x_Ship_To_First_Name' => $order->delivery['firstname'],
							'x_Ship_To_Last_Name' => $order->delivery['lastname'],
							'x_Ship_To_Address' => $order->delivery['street_address'],
							'x_Ship_To_City' => $order->delivery['city'],
							'x_Ship_To_State' => $order->delivery['state'],
							'x_Ship_To_Zip' => $order->delivery['postcode'],
							'x_Country' => $order->delivery['country'],
							'x_email_Customer' => MODULE_PAYMENT_AUTHORIZENET_EMAIL_CUSTOMER == 'true' ? 'TRUE': 'FALSE',
							'x_email_Merchant' => MODULE_PAYMENT_AUTHORIZENET_EMAIL_MERCHANT == 'true' ? 'TRUE': 'FALSE',
							'x_Customer_IP' => REMOTE_ADDR);
		
		$response = http_request("https://secure.authorize.net/gateway/transact.dll", $data_array);
		$response_vars = split('\|,\|', $response);
		if ($response_vars[0] != '|1') {
			shop_redirect(shop_href_link('checkout_payment.php', 'error_message=' . urlencode(MODULE_PAYMENT_CC_TEXT_ERROR . ' ' . $response_vars[3]), 'SSL'));
		}
		$order->info['cc_approval'] = $response_vars[4];
	}

	function after_process() {
	}

	function check() {
	  return defined('MODULE_PAYMENT_AUTHORIZENET_STATUS');
	}

	function install() {
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_PAYMENT_AUTHORIZENET_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Login Username', 'MODULE_PAYMENT_AUTHORIZENET_LOGIN', 'testing', 'The login username used for the Authorize.net service', '6', '0', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Login Password', 'MODULE_PAYMENT_AUTHORIZENET_PASSWORD', 'testing', 'The Authorize.net admin password', '6', '0', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_AUTHORIZENET_TESTMODE', 'Test', 'Transaction mode used for processing orders', '6', '0', 'shop_cfg_select_option(array(\'Test\', \'Production\'), ', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Customer Notifications', 'MODULE_PAYMENT_AUTHORIZENET_EMAIL_CUSTOMER', 'false', 'Should Authorize.Net e-mail a receipt to the customer?', '6', '0', 'shop_cfg_select_option(array(\'true\', \'false\'), ', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Merchant Notifications', 'MODULE_PAYMENT_AUTHORIZENET_EMAIL_MERCHANT', 'true', 'Should Authorize.Net e-mail a receipt to the store owner?', '6', '0', 'shop_cfg_select_option(array(\'true\', \'false\'), ', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_PAYMENT_AUTHORIZENET_%'");
	}

	function keys() {
	  return array('MODULE_PAYMENT_AUTHORIZENET_STATUS', 'MODULE_PAYMENT_AUTHORIZENET_LOGIN', 'MODULE_PAYMENT_AUTHORIZENET_PASSWORD', 'MODULE_PAYMENT_AUTHORIZENET_TESTMODE', 'MODULE_PAYMENT_AUTHORIZENET_EMAIL_CUSTOMER', 'MODULE_PAYMENT_AUTHORIZENET_EMAIL_MERCHANT');
	}
}
