<?php
/*
	eShox OS
	http://www.eshox.com/

	Copyright (c) 2003, Secure.cc, Inc.

	Released under the GNU General Public License

*/
  
  class secpay {
	var $code, $title, $description, $enabled;

	function secpay() {
	  $this->code = 'secpay';
	  $this->title = 'SECPay';
	  $this->shop_title = MODULE_PAYMENT_CC_TEXT_TITLE;
	  $this->description = '';
	  $this->signup = 'http://www.secpay.com/';
	  $this->enabled = defined('MODULE_PAYMENT_SECPAY_STATUS');
	  $this->recommend_level = 5;
	  $this->version = "2.0";
	}

	function javascript_validation() {
	  return shop_draw_cc_javascript_validation($this->code);
	}

	function selection() {
	  return shop_draw_cc_input();
	}

	function pre_confirmation_check() {
	  if ($_POST['payment_selected'] == $this->code) shop_validate_cc($_POST['cc_owner'],$_POST['cc_number'], $_POST['cc_expires_month'], $_POST['cc_expires_year'], $_POST['cc_code']);
	}

	function confirmation() {
	  return false;
	}

	function process_button() {
	  $process_button_string = shop_draw_hidden_field('cc_owner', $_POST['cc_owner']) . 
	                           shop_draw_hidden_field('cc_number', $_POST['cc_number']) . 
	                           shop_draw_hidden_field('cc_code', $_POST['cc_code']) . UNIX_RETURN .
	                           shop_draw_hidden_field('cc_expires_month', $_POST['cc_expires_month']) . UNIX_RETURN .
	                           shop_draw_hidden_field('cc_expires_year', $_POST['cc_expires_year']) . UNIX_RETURN;

	  return $process_button_string;
	}

	function before_process() {
	  global $order;
	  
	  $card_types = array('AMEX' => ereg("^3[47].{13}$", $_POST['cc_number']),
						  'VISA' => ereg("^4.{15}$|^4.{12}$", $_POST['cc_number']),
						  'MC' => ereg("^5[1-5].{14}$", $_POST['cc_number']));
	  $cc_type = null;
	  foreach($card_types as $card_type=>$match) if ($match == 1) $cc_type = $card_type;
	  
	  $data_array = array('merchant' => MODULE_PAYMENT_SECPAY_MERCHANT_ID,
						  'trans_id' => $order->info['orders_id'],
						  'amount' => number_format($order->info['total'], 2),
						  'customer' => $_POST['cc_owner'],
						  'card_type' => $cc_type,
						  'card_no' => $_POST['cc_number'],
						  'expiry' => $_POST['cc_expires'],
						  'bill_name' => $order->customer['firstname'] . ' ' . $order->customer['lastname'],
						  'bill_addr_1' => $order->customer['street_address'],
						  'bill_addr_2' => $order->customer['street_address2'],
						  'bill_city' => $order->customer['city'],
						  'bill_state' => $order->customer['state'],
						  'bill_country' => $order->customer['state'],
						  'bill_post_code' => $order->customer['postcode'],
						  'options' => 'test_status=' . ((MODULE_PAYMENT_SECPAY_TESTMODE == 'Test') ? 'A' : 'N') . ',dups=false' . 
						  (($_POST['cc_code']) ? ',cv2=' . $_POST['cc_code'] . ',req_cv2=true' : ',req_cv2=false'));
		
	  $request = substr(http_request("https://www.secpay.com/java-bin/ValCard", $data_array), 1);
	  preg_match_all('/([^=]+)=([^&]+)&/', $request, $response);
	  
	  $result = array();
	  for ($x=0; $x<sizeof($response[1]); $x++) {
	    $result[$response[1][$x]] = $response[2][$x];
	  }
	  
	  if ($result['valid'] == 'false') {
		shop_redirect(shop_href_link('checkout_payment.php', 'error_message=' . urlencode(MODULE_PAYMENT_CC_TEXT_ERROR) . ' ' . $result['message'], 'SSL'));
	  }
	  
	  $order->info['cc_approval'] = $result['auth_code'];
	}

	function after_process() {
	  return false;
	}

	function check() {
	  return defined('MODULE_PAYMENT_SECPAY_STATUS');
	}

	function install() {
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_key, configuration_value) values ('MODULE_PAYMENT_SECPAY_STATUS', 'true')");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, date_added) values ('Merchant ID', 'MODULE_PAYMENT_SECPAY_MERCHANT_ID', 'secpay', 'Your Merchant ID.', '6', '1', now())");
	  shop_db_query("insert into " . DB_PREFIX . "configuration (configuration_title, configuration_key, configuration_value, configuration_description, configuration_group_id, sort_order, set_function, date_added) values ('Transaction Mode', 'MODULE_PAYMENT_SECPAY_TESTMODE', 'Test', 'Transaction mode used for processing orders', '6', '2', 'shop_cfg_select_option(array(\'Test\', \'Production\'), ', now())");
	}

	function remove() {
	  shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_PAYMENT_SECPAY__%'");
	}

	function keys() {
	  return array('MODULE_PAYMENT_SECPAY_STATUS', 'MODULE_PAYMENT_SECPAY_MERCHANT_ID', 'MODULE_PAYMENT_SECPAY_TESTMODE');
	}
  }