<?php

/*
	eShox 3 Commerce Solution
	http://www.eshox.com/
	
	Copyright (c) 2003, Secure.cc, Inc.

*/

class usps {
	var $code = 'usps';
	var $title = 'United States Postal Service&reg;';
	var $icon = 'images/shipping/shipping_usps.gif';
	var $description = 'Provides real-time shipping quotes via the Post Office&trade; for shipments originating within the USA.';
	var $recommend_level = 3.5;
	var $version = "3.0";
	var $quote = array();
	var $api_url = 'http://Production.ShippingAPIs.com/ShippingAPI.dll';

	function usps() {
		$code = strtoupper($this->code);
		$this->enabled = defined("MODULE_SHIPPING_{$code}_STATUS");
	}
	
	function display($code = false) {
		$products = array('BPM'=>'Bound Printed Matter&reg;',
                      'EXM'=>'Express Mail&reg;',
                      'EME'=>'Express Mail&reg; Flat-Rate Envelope',
                      'EMI'=>'Express Mail&reg; International (EMS)',
                      'EIE'=>'Express Mail&reg; International (EMS) Flat Rate Envelope',
                      'EPO'=>'Express Mail&reg; PO to PO',
                      'GEG'=>'Global Express Guaranteed&reg;',
                      'GEN'=>'Global Express Guaranteed&reg; Non-Document Non-Rectangular',
                      'GER'=>'Global Express Guaranteed&reg; Non-Document Rectangular',
                      'LMA'=>'Library Mail&reg;',
                      'MMA'=>'Media Mail&reg;',
                      'PAP'=>'Parcel Post&reg;',
                      'PRM'=>'Priority Mail&reg;',
                      'PMB'=>'Priority Mail&reg; Flat-Rate Box',
                      'PME'=>'Priority Mail&reg; Flat-Rate Envelope',
                      'PML'=>'Priority Mail&reg; Large Flat-Rate Box',
                      'PMI'=>'Priority Mail&reg; International',
                      'PIB'=>'Priority Mail&reg; International Flat Rate Box');
		if ($code) return $products[$code];
		return $products;
	}
	
	function quote() {
		global $shipping_weight, $shipping_num_boxes, $address_values;
		$code = strtoupper($this->code);
		$weight = $shipping_weight;
		$pounds = floor($shipping_weight);
		$ounces = floor(($weight - $pounds)/0.0625);
		$rates = array();
		
		if ($address_values['country_code'] == 'US') {
			$request_api = 'RateV2';
			$request_type = 'RateV2Request';
			$request_elements = array('Service'=>'ALL','ZipOrigination'=>STORE_ORIGIN_ZIP,'ZipDestination'=>$address_values['postcode'],'Pounds'=>$pounds,'Ounces'=>$ounces,'Size'=>'REGULAR','Machinable'=>'FALSE');
		} else {
			$request_api = 'IntlRate';
			$request_type = 'IntlRateRequest';
			$request_elements = array('Pounds'=>$pounds,'Ounces'=>$ounces,'MailType'=>'PACKAGE','Country'=>$address_values['country']);
		}
		$data = '';
		foreach ($request_elements as $xml => $value) 
			$data .= '<' . $xml . '>' . $value . '</' . $xml . '>';

		$request_query = '<?xml version=\'1.0\'?>
<' . $request_type . ' USERID="839SECUR7799" PASSWORD="339YO16NN875">' . 
			'<Package ID="0">' . 
				$data . 
			'</Package>' . 
		'</' . $request_type . '>';

		$res = http_request($this->api_url, array('API'=>$request_api,'XML'=>$request_query));
		$products = array('Bound Printed Matter'=>'BPM',
                      'Express Mail'=>'EXM',
                      'Express Mail Flat-Rate Envelope'=>'EME',
                      'Express Mail International (EMS)'=>'EMI',
                      'Express Mail International (EMS) Flat Rate Envelope'=>'EIE',
                      'Express Mail PO to PO'=>'EPO',
                      'Global Express Guaranteed'=>'GEG',
                      'Global Express Guaranteed Non-Document Non-Rectangular'=>'GEN',
                      'Global Express Guaranteed Non-Document Rectangular'=>'GER',
                      'Library Mail'=>'LMA',
                      'Media Mail'=>'MMA',
                      'Parcel Post'=>'PAP',
                      'Priority Mail'=>'PRM',
                      'Priority Mail Flat-Rate Box'=>'PMB',
                      'Priority Mail Flat-Rate Envelope'=>'PME',
                      'Priority Mail Large Flat-Rate Box'=>'PML',
                      'Priority Mail International'=>'PMI',
                      'Priority Mail International Flat Rate Box'=>'PIB');

		$shipping_usps_global_cost = 9999;

		if ($address_values['country_code'] == 'US') {
			preg_match_all('~<Postage><MailService>([^<]+)</MailService><Rate>([0-9.]+)</Rate></Postage>~',$res,$result_array);
			foreach ($result_array[1] as $id=>$svc) {
				if ($result_array[2][$id]) {
					if (constant("MODULE_SHIPPING_{$code}_".$products[$result_array[1][$id]]) == 'true') {
						$rates[$result_array[2][$id]] = array($products[$result_array[1][$id]],$this->display($products[$result_array[1][$id]]),$this->shipping_markup($result_array[2][$id], $shipping_num_boxes),'');
					}
				}
			}
		} else {
			preg_match_all('~<Postage>([0-9.]+)</Postage><SvcCommitments>([^<]+)</SvcCommitments><SvcDescription>([^<]+)</SvcDescription><MaxDimensions>[^<]+</MaxDimensions><MaxWeight>([0-9]+)</MaxWeight></Service>~',$res,$result_array);
			foreach ($result_array[1] as $id=>$svc) {
			  if ($result_array[3][$id] && $result_array[4][$id]>$weight && !strstr($result_array[3][$id],'Guaranteed Document')) {
				  if (constant("MODULE_SHIPPING_{$code}_".$products[$result_array[3][$id]]) == 'true') {
				    $rates[$result_array[1][$id]] = array($products[$result_array[3][$id]],$this->display($products[$result_array[3][$id]]),$this->shipping_markup($result_array[1][$id], $shipping_num_boxes),strtolower($result_array[2][$id]));
				  }
				}
			}
		}
		ksort($rates); $rates_array = array();
		foreach ($rates as $id=>$rate) {
			if ($rate[2] < $shipping_usps_global_cost) $shipping_usps_global_cost = $rate[2];
			$this->quote[] = array('Method' => 'USPS ' . $rate[1], 'Service' => 'USPS ' . $rate[1], 'TotalCharges' => $rate[2]);
		}
		return $shipping_usps_global_cost;
	}
	
	function shipping_markup($total, $shipping_num_boxes) {
		$total = $total + ($total * (SHIPPING_MARK/100));
		$total = (SHIPPING_HANDLING_TOTAL + $total) * $shipping_num_boxes;
		return $total;
	}

	function check() {
		$code = strtoupper($this->code);
		return defined("MODULE_SHIPPING_{$code}_STATUS") ? 1 : 0;
	}

	function install() {
		$code = strtoupper($this->code);
		shop_db_perform('configuration',array('configuration_key'=>"MODULE_SHIPPING_{$code}_STATUS",'configuration_value'=>'1'),'insert');
		$keys_array = $this->display(); $x=0;
		foreach ($keys_array as $key=>$title) {
			shop_db_perform('configuration',array('configuration_title'=>$title, 'configuration_key'=>"MODULE_SHIPPING_{$code}_{$key}", 'configuration_value'=>'true', 'configuration_group_id'=>6, 'sort_order'=>++$x, 'use_function'=>'shop_cfg_checkbox_display(', 'set_function'=>'shop_cfg_checkbox(', 'date_added'=>'now()'),'insert');
		}
	}

	function remove() {
		$code = strtoupper($this->code);
		shop_db_query("delete from " . DB_PREFIX . "configuration where configuration_key like 'MODULE_SHIPPING_{$code}_%'");
	}

	function keys() {
		$keys_array = $this->display();
		$code = strtoupper($this->code);
		$keys = array('MODULE_SHIPPING_{$code}_STATUS');
		foreach ($keys_array as $key=>$title) $keys[] = "MODULE_SHIPPING_{$code}_{$key}";
		return $keys;
	}
}